#line 1 "C:/Users/Software/Desktop/Perfect Envirenment Demo/PerfectEnvironment_events_code.c"
#line 1 "c:/users/software/desktop/perfect envirenment demo/perfectenvironment_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 TTextAlignVertical TextAlignVertical;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 void (*OnSwipeLeftPtr)();
 void (*OnSwipeRightPtr)();
 void (*OnSwipeUpPtr)();
 void (*OnSwipeDownPtr)();
 void (*OnZoomInPtr)();
 void (*OnZoomOutPtr)();
};

extern TScreen Screen1;
extern TImage Image10;
extern TImage Image9;
extern TImage Image11;
extern TImage Image1;
extern TImage Image8;
extern TImage Image7;
extern TImage Image6;
extern TImage Image5;
extern TImage Image3;
extern TImage Image4;
extern TImage Image2;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TButton Button1;
extern TLabel Label14;
extern TButton * const code Screen1_Buttons[1];
extern TLabel * const code Screen1_Labels[8];
extern TImage * const code Screen1_Images[11];




void Button1OnClick();




extern char Image10_Caption[];
extern char Image9_Caption[];
extern char Image11_Caption[];
extern char Image1_Caption[];
extern char Image8_Caption[];
extern char Image7_Caption[];
extern char Image6_Caption[];
extern char Image5_Caption[];
extern char Image3_Caption[];
extern char Image4_Caption[];
extern char Image2_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Button1_Caption[];
extern char Label14_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/software/desktop/perfect envirenment demo/perfectenvironment_resources.h"
const code char Tahoma23x23_Bold[];
const code char Tahoma29x29_Bold[];
const code char Tahoma11x13_Regular[];
const code char water2_jpg[11944];
const code char water1_jpg[11945];
const code char water3_jpg[11901];
const code char screen_bmp[261126];
const code char tv_jpg[3460];
const code char c_jpg[3512];
const code char u_bmp[5726];
const code char p_jpg[3550];
const code char h_jpg[3642];
const code char a_jpg[4025];
const code char t_jpg[3314];
#line 6 "C:/Users/Software/Desktop/Perfect Envirenment Demo/PerfectEnvironment_events_code.c"
extern button1_flag;
extern button1_active;





void Button1OnClick()
{
 button1_active = 1;

 if ( button1_flag == 1 )
 button1_flag = 0;
 if ( button1_flag == 0 )
 button1_flag = 1;
}
