#line 1 "C:/Users/Software/Desktop/Perfect Envirenment Demo/PerfectEnvironment_main.c"
#line 1 "c:/users/software/desktop/perfect envirenment demo/perfectenvironment_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 TTextAlignVertical TextAlignVertical;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
 unsigned int ImagesCount;
 TImage * const code *Images;
 void (*OnSwipeLeftPtr)();
 void (*OnSwipeRightPtr)();
 void (*OnSwipeUpPtr)();
 void (*OnSwipeDownPtr)();
 void (*OnZoomInPtr)();
 void (*OnZoomOutPtr)();
};

extern TScreen Screen1;
extern TImage Image10;
extern TImage Image9;
extern TImage Image11;
extern TImage Image1;
extern TImage Image8;
extern TImage Image7;
extern TImage Image6;
extern TImage Image5;
extern TImage Image3;
extern TImage Image4;
extern TImage Image2;
extern TLabel Label7;
extern TLabel Label8;
extern TLabel Label9;
extern TLabel Label10;
extern TLabel Label11;
extern TLabel Label12;
extern TLabel Label13;
extern TButton Button1;
extern TLabel Label14;
extern TButton * const code Screen1_Buttons[1];
extern TLabel * const code Screen1_Labels[8];
extern TImage * const code Screen1_Images[11];




void Button1OnClick();




extern char Image10_Caption[];
extern char Image9_Caption[];
extern char Image11_Caption[];
extern char Image1_Caption[];
extern char Image8_Caption[];
extern char Image7_Caption[];
extern char Image6_Caption[];
extern char Image5_Caption[];
extern char Image3_Caption[];
extern char Image4_Caption[];
extern char Image2_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char Button1_Caption[];
extern char Label14_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void DrawImage(TImage *AImage);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/users/software/desktop/perfect envirenment demo/adc.h"
#line 1 "c:/users/software/desktop/perfect envirenment demo/demo_types.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"
#line 3 "c:/users/software/desktop/perfect envirenment demo/adc.h"
void airquality_adcInit()
{
 ADC1_Init();
 ADC_Set_Input_Channel( _ADC_CHANNEL_4 );
}

uint32_t airquality_readADC()
{
 uint32_t readADC;

 readADC = ADC1_Read( 4 );

 return readADC;
 }
#line 1 "c:/users/software/desktop/perfect envirenment demo/demo_types.h"
#line 1 "c:/users/software/desktop/perfect envirenment demo/demo_config.h"
#line 1 "c:/users/software/desktop/perfect envirenment demo/demo_types.h"
#line 3 "c:/users/software/desktop/perfect envirenment demo/demo_config.h"
const uint32_t _FAN4_I2C_CFG[ 1 ] =
{
 100000
};

const uint32_t _PRESSURE6_I2C_CFG[ 1 ] =
{
 100000
};

const uint32_t _AMBIENT5_I2C_CFG[ 1 ] =
{
 100000
};

const uint32_t _UV_SPI_CFG[ 2 ] =
{
 _SPI_FPCLK_DIV256,
 _SPI_FIRST_CLK_EDGE_TRANSITION |
 _SPI_CLK_IDLE_LOW |
 _SPI_MASTER |
 _SPI_MSB_FIRST |
 _SPI_8_BIT |
 _SPI_SSM_ENABLE |
 _SPI_SS_DISABLE |
 _SPI_SSI_1
};

const uint32_t _TEMPHUM6_I2C_CFG[ 1 ] =
{
 100000
};

const uint32_t _AIR_QUALITY4_I2C_CFG[ 1 ] =
{
 100000
};
#line 29 "C:/Users/Software/Desktop/Perfect Envirenment Demo/PerfectEnvironment_main.c"
uint16_t Pressure;
uint8_t Temperature;
uint16_t AIRQ3_Data[ 5 ] = { 0 };
char Pressure_str[ 50 ] = { 0 };
char Temperature_str[ 50 ] = { 0 };
char CO2_str[ 256 ] = { 0 };
char TVOC_str[ 256 ] = { 0 };
char Ambient_light_str[ 50 ] = { 0 };
char UV_str[ 250 ] = { 0 };
char Humidity_str[ 50 ] = { 0 };

uint16_t rTime;
uint16_t i;
uint16_t lth;
uint16_t hth;
float highResLightLevel;
float highThreshold = 500.0;
float lowThreshold = 100.0;

float uvData;
float uvDataOld = 1.0;
float sensitivity = 20.0;

uint16_t PartID;
float TEMP;
float HUM;

uint8_t wdState = 0;
uint8_t wdStateOld = 0;
uint8_t flag = 1;

uint16_t valueADC;

uint8_t buffer_data[ 6 ];
uint16_t data_buffer[ 2 ];

uint8_t button1_flag = 0;
uint8_t button1_active = 0;

uint8_t timer_flag = 0;

void decimal_trim( char * value, int num_of_dec )
{
 int i,n;
 n = strlen( value );
 for ( i=0; i<n; i++ )
 {
 if ( value[ i ]=='.' )
 {
 if ( num_of_dec == 0 )
 {
 value[ i ]='\0';
 }
 else
 {
 num_of_dec++;
 value[ i + num_of_dec ]='\0';
 }
 break;
 }
 }
}


void formatFloatStr( char *s )
{
 uint8_t i;
 uint8_t point;
 uint8_t degree = 0;
 for( i = 0, point = 0; s[i] != '\0'; i++ )
 {
 if( s[i] == '.' ) {
 point = i;
 break;
 }
 }
 for( i = point + 1; s[i] != '\0'; i++ ) {
 if( s[i] == '-' ) {
 i++;
 while( s[i] == '0' ) {
 i++;
 }
 degree = s[i] - '0';
 break;
 }
 }
 if( degree > 4 ) {
 s[point - 1] = '0';
 s[point + 1] = '0';
 s[point + 2] = '0';
 s[point + 3] = '0';
 s[point + 4] = '\0';
 }
 else if( degree == 4 ) {
 if( s[point - 1] >= '5' ) {
 s[point - 1] = '0';
 s[point + 1] = '0';
 s[point + 2] = '0';
 s[point + 3] = '1';
 s[point + 4] = '\0';
 }
 else {
 s[point - 1] = '0';
 s[point + 1] = '0';
 s[point + 2] = '0';
 s[point + 3] = '0';
 s[point + 4] = '\0';
 }
 }
 else {
 switch(degree) {
 case 0: s[point + 4] = '\0';
 break;
 case 1: s[point + 3] = s[point + 2];
 s[point + 2] = s[point + 1];
 s[point + 1] = s[point - 1];
 s[point - 1] = '0';
 s[point + 4] = '\0';
 break;
 case 2: s[point + 3] = s[point + 1];
 s[point + 2] = s[point - 1];
 s[point + 1] = '0';
 s[point - 1] = '0';
 s[point + 4] = '\0';
 break;
 case 3: s[point + 3] = s[point - 1];
 s[point + 2] = '0';
 s[point + 1] = '0';
 s[point - 1] = '0';
 s[point + 4] = '\0';
 break;
 default: s[point + 4] = '\0';
 break;
 }
 }
}

void turn_fan_on_and_off( )
{
 if ( button1_active == 1 )
 {
 if ( strcmp( Label14_Caption, "ON") == 0 )
 {
 strcpy(Label14_Caption, "OFF");
 fan4_setOutput( _FAN4_MIN_VOLT_SCALE, _FAN4_BOOST_START_TIMER_DIS );
 }
 else if ( strcmp( Label14_Caption, "OFF" ) == 0 )
 {
 strcpy( Label14_Caption, "ON" );
 fan4_setOutput( _FAN4_MAX_VOLT_SCALE, _FAN4_BOOST_START_TIMER_DIS );
 }

 if ( flag <= 1 )
 {
 DrawImage( &Image9 );
 }
 else if ( flag == 2 )
 {
 DrawImage( &Image10 );
 }
 else if ( flag >= 3 )
 {
 DrawImage( &Image11 );
 }
 else
 DrawImage( &Image9 );

 DrawButton( &Button1 );
 DrawLabel( &Label14 );
 button1_active = 0;
 }
}

void systemInit( )
{

 mikrobus_i2cInit( _MIKROBUS1, &_FAN4_I2C_CFG[ 0 ] );
 Delay_ms( 10 );



 mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_i2cInit( _MIKROBUS5, &_PRESSURE6_I2C_CFG[ 0 ] );
 Delay_ms( 10 );



 mikrobus_gpioInit( _MIKROBUS5, _MIKROBUS_INT_PIN, _GPIO_INPUT );
 mikrobus_i2cInit( _MIKROBUS5, &_AMBIENT5_I2C_CFG[ 0 ] );
 Delay_ms( 10 );



 mikrobus_gpioInit( _MIKROBUS4, _MIKROBUS_AN_PIN, _GPIO_INPUT );
 mikrobus_gpioInit( _MIKROBUS4, _MIKROBUS_CS_PIN, _GPIO_OUTPUT );
 mikrobus_gpioInit( _MIKROBUS4, _MIKROBUS_RST_PIN, _GPIO_OUTPUT );
 mikrobus_spiInit( _MIKROBUS4, &_UV_SPI_CFG[ 0 ] );
 Delay_ms( 10 );



 mikrobus_i2cInit( _MIKROBUS3, &_TEMPHUM6_I2C_CFG[ 0 ] );



 mikrobus_gpioInit( _MIKROBUS3, _MIKROBUS_INT_PIN, _GPIO_INPUT );



 mikrobus_i2cInit( _MIKROBUS2, &_AIR_QUALITY4_I2C_CFG[ 0 ] );
 Delay_ms( 10 );


 mikrobus_logInit( _LOG_USBUART, 9600 );
}

void applicationInit( )
{

 fan4_i2cDriverInit( ( const uint8_t* )&_MIKROBUS1_GPIO, ( const uint8_t* )&_MIKROBUS1_I2C, _FAN4_SLAVE_ADDR );
 Delay_ms( 10 );
 fan4_setOutput( _FAN4_MIN_VOLT_SCALE, _FAN4_BOOST_START_TIMER_DIS );



 pressure6_i2cDriverInit( ( const uint8_t* )&_MIKROBUS5_GPIO, ( const uint8_t* )&_MIKROBUS5_I2C, _PRESSURE6_DEF_SLAVE_ADDRESS );
 pressure6_powerON( );
 Delay_1sec( );
 pressure6_writeByte(_PRESSURE6_REG_MODE_CONTROL,
 _PRESSURE6_MC_AVE_NUM_SINGLE |
 _PRESSURE6_MC_DATA_READY_ENABLED |
 _PRESSURE6_MC_FULL_DATA_ENABLED |
 _PRESSURE6_MC_WATER_MARK_ENABLED |
 _PRESSURE6_MC_MODE_CONTINUOUS);



 ambient5_i2cDriverInit( ( const uint8_t* )&_MIKROBUS5_GPIO, ( const uint8_t* )&_MIKROBUS5_I2C, _AMBIENT5_DEVICE_ADDRESS );
 Delay_ms( 10 );
 ambient5_powerOn( );
 Delay_ms( 10 );

 ambient5_setLowLightLevelThreshold( lowThreshold );
 ambient5_setHighLightLevelThreshold( highThreshold );

 rTime = ambient5_getRefreshTime( );



 uv_spiDriverInit( ( const uint8_t* )&_MIKROBUS4_GPIO, ( const uint8_t* )&_MIKROBUS4_SPI );
 uv_enableSensor( );
 Delay_ms( 10 );



 temphum6_i2cDriverInit( ( const uint8_t* )&_MIKROBUS3_GPIO, ( const uint8_t* )&_MIKROBUS3_I2C, _TEMPHUM6_DEVICE_SLAVE_ADDRESS );
 temphum6_reset( );
 PartID = temphum6_getPartID( );



 waterdetect_gpioDriverInit( ( const uint8_t* )&_MIKROBUS3_GPIO );
 Delay_ms( 10 );



 air_quality4_i2cDriverInit( ( const uint8_t* )&_MIKROBUS2_GPIO, ( const uint8_t* )&_MIKROBUS2_I2C, 0x58 );
 Delay_ms( 10 );

 air_quality4_init( );
 air_quality4_getID( &buffer_data[ 0 ] );

}

void applicationTask( )
{

 pressure6_waitingForNewData( );
 Pressure = pressure6_getPressure( );
 Temperature = pressure6_getTemperatre( );

 IntToStr( Pressure, Pressure_str );
 DrawImage( &Image5 );
 Label10.Caption = Pressure_str;
 DrawLabel( &Label10 );



 highResLightLevel = ambient5_getHighResolutionLightLevel( );
 FloatToStr( highResLightLevel, Ambient_light_str );
 decimal_trim( Ambient_light_str, 1 );
 DrawImage( &Image4 );
 Label9.Caption = Ambient_light_str;
 DrawLabel( &Label9 );



 uvData = uv_calculateUV( );
#line 336 "C:/Users/Software/Desktop/Perfect Envirenment Demo/PerfectEnvironment_main.c"
 uvData /=1000;
 uvData -= 0.98;
 uvData *= 8.24;

 FloatToStr( uvData, UV_str );
 formatFloatStr( UV_str );

 DrawImage( &Image6 );
 Label11.Caption = UV_str;
 DrawLabel( &Label11 );



 TEMP = temphum6_readTemperature( _TEMPHUM6_TEMP_IN_CELSIUS );
 FloatToStr( TEMP, Temperature_str );
 decimal_trim( Temperature_str, 1 );
 DrawImage( &Image2 );
 Label7.Caption = Temperature_str;
 DrawLabel( &Label7 );

 HUM = temphum6_readRelativeHuminidy( );
 FloatToStr( HUM, Humidity_str );
 decimal_trim( Humidity_str, 1 );
 DrawImage( &Image3 );
 Label8.Caption = Humidity_str;
 DrawLabel( &Label8 );



 wdState = waterdetect_getStatus( );

 if ( wdState != wdStateOld )
 {
 if ( wdState > wdStateOld )
 {
 flag++;
 }
 if ( wdState < wdStateOld )
 {
 flag--;
 }
 wdStateOld = wdState;

 if ( flag <= 1 )
 {
 DrawImage( &Image9 );
 }
 else if ( flag == 2 )
 {
 DrawImage( &Image10 );
 }
 else if ( flag >= 3)
 {
 DrawImage( &Image11 );
 }
 DrawButton( &Button1 );
 DrawLabel( &Label14 );
 }



 air_quality4_setBaseline( );

 air_quality4_getCO2AndTVOC( &data_buffer[ 0 ] );

 IntToStr(data_buffer[ 0 ], CO2_str);
 decimal_trim( CO2_str, 2 );
 DrawImage( &Image7 );
 Label12.Caption = CO2_str;
 DrawLabel( &Label12 );

 IntToStr(data_buffer[ 1 ], TVOC_str);
 decimal_trim( TVOC_str, 2 );
 DrawImage( &Image8 );
 Label13.Caption = TVOC_str;
 DrawLabel( &Label13 );


}

void InitTimer2( )
{
 RCC_APB1ENR.TIM2EN = 1;
 TIM2_CR1.CEN = 0;
 TIM2_PSC = 3999;
 TIM2_ARR = 62999;
 NVIC_IntEnable( IVT_INT_TIM2 );
 TIM2_DIER.UIE = 1;
 TIM2_CR1.CEN = 1;
 EnableInterrupts( );
}

void Timer2_interrupt( ) iv IVT_INT_TIM2
{
 TIM2_SR.UIF = 0;
 timer_flag = 1;
}

void main( )
{
 systemInit( );
 applicationInit( );

 Start_TP( );
 InitTimer2( );

 while ( 1 )
 {
 Check_TP( );

 if ( timer_flag == 1 )
 {
 applicationTask( );
 timer_flag = 0;
 }
 turn_fan_on_and_off( );
 }

}
