Project description:
- Turtle Terrarium is the ideal housing for aquatic turtles and other marine reptiles, amphibians, and invertebrates. 
- This application is using the several sensors which show their values on TFT Capacitive Board,
refreshed every few seconds.
- When Water Detect click sense the change, on display will appear picture with two or three blue waves,
depending on the amount of fluid.
- By touching the fan thumbnail, the fan starts working and the current status on the screen changes 
from OFF to ON.

Hardware requirements:
- Fusion for ARM v8 development board
- MCU CARD for STM32 STM32F407ZG
- TFT Board 4 Capacitive
- Air Quality 4 Click
- Fan 4 Click
- Water Detect Click
- Temp&Hum 6 Click
- UV Click
- Ambient 5 Click
- Pressure 6 Click
- 4 x mikroBUS Shuttle
- 2 x Shuttle Click
- Fan ( DC 5V )

Hardware settings:
- Attach two wires of fan to Fan 4 Click
- Fusion for ARM v8 Board
    - 1st slot: place Air Quality 4 Click
    - 2nd slot: place Fan 4 Click
    - 3rd slot: place Water Detect Click and Temp&Hum 6 Click 
                using Shuttle Click and two mikroBUS Shuttle add-ons 
    - 4th slot: place UV Click
    - 5th slot: place Ambient 5 Click and Pressure 6 Click
                using Shuttle Click and two mikroBUS Shuttle add-ons 
- Place TFT Board 4 Capacitive on Fusion for ARM v8 development Board

Software requirements:
- Mikro C PRO for ARM and CodeGrip Suite

Software settings:
- Open MikroC PRO for ARM program, and first it is necessary to instal packages for 
Air Quality 4 Click, Fan 4 Click, Water Detect Click, Temp&Hum 6 Click, UV Click, Ambient 5 Click 
and Pressure 6 Click from Libstock ( using Libstock manager ). When searching path for those packages 
are included, build and program the code. 
- Instead of that you can just write down the hex file using CodeGrip Suite.
- Enjoy the application :)
