_Write_to_Data_Lines:
;PerfectEnvironment_driver.c,38 :: 		void Write_to_Data_Lines(  unsigned char _hi, unsigned char _lo ) {
; _lo start address is: 4 (R1)
; _hi start address is: 0 (R0)
; _lo end address is: 4 (R1)
; _hi end address is: 0 (R0)
; _hi start address is: 0 (R0)
; _lo start address is: 4 (R1)
;PerfectEnvironment_driver.c,39 :: 		GPIOG_ODR = ( unsigned int ) ( _lo | ( _hi << 8 ) );
LSLS	R2, R0, #8
UXTH	R2, R2
; _hi end address is: 0 (R0)
ORR	R3, R1, R2, LSL #0
UXTH	R3, R3
; _lo end address is: 4 (R1)
MOVW	R2, #lo_addr(GPIOG_ODR+0)
MOVT	R2, #hi_addr(GPIOG_ODR+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,40 :: 		}
L_end_Write_to_Data_Lines:
BX	LR
; end of _Write_to_Data_Lines
_Set_Index:
;PerfectEnvironment_driver.c,42 :: 		void Set_Index( unsigned short index ) {
; index start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; index end address is: 0 (R0)
; index start address is: 0 (R0)
;PerfectEnvironment_driver.c,43 :: 		TFT_RS = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,44 :: 		Write_to_Data_Lines(  0, index );
UXTB	R1, R0
; index end address is: 0 (R0)
MOVS	R0, #0
BL	_Write_to_Data_Lines+0
;PerfectEnvironment_driver.c,45 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,46 :: 		asm nop;
NOP
;PerfectEnvironment_driver.c,47 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,48 :: 		}
L_end_Set_Index:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Set_Index
_Write_Command:
;PerfectEnvironment_driver.c,50 :: 		void Write_Command( unsigned short cmd ) {
; cmd start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; cmd end address is: 0 (R0)
; cmd start address is: 0 (R0)
;PerfectEnvironment_driver.c,51 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,52 :: 		Write_to_Data_Lines( 0, cmd );
UXTB	R1, R0
; cmd end address is: 0 (R0)
MOVS	R0, #0
BL	_Write_to_Data_Lines+0
;PerfectEnvironment_driver.c,53 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,54 :: 		asm nop;
NOP
;PerfectEnvironment_driver.c,55 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,56 :: 		}
L_end_Write_Command:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Write_Command
_Write_Data:
;PerfectEnvironment_driver.c,58 :: 		void Write_Data( unsigned int _data ) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
STRH	R0, [SP, #4]
;PerfectEnvironment_driver.c,59 :: 		TFT_RS = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,60 :: 		Write_to_Data_Lines( Hi( _data ), Lo( _data ) );
ADD	R3, SP, #4
LDRB	R1, [R3, #0]
UXTB	R2, R1
ADDS	R1, R3, #1
LDRB	R1, [R1, #0]
UXTB	R0, R1
UXTB	R1, R2
BL	_Write_to_Data_Lines+0
;PerfectEnvironment_driver.c,61 :: 		TFT_WR = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,62 :: 		asm nop;
NOP
;PerfectEnvironment_driver.c,63 :: 		TFT_WR = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,64 :: 		}
L_end_Write_Data:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _Write_Data
PerfectEnvironment_driver_InitializeTouchPanel:
;PerfectEnvironment_driver.c,66 :: 		static void InitializeTouchPanel( ) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;PerfectEnvironment_driver.c,67 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R2, #lo_addr(_Write_Data+0)
MOVT	R2, #hi_addr(_Write_Data+0)
MOVW	R1, #lo_addr(_Write_Command+0)
MOVT	R1, #hi_addr(_Write_Command+0)
MOVW	R0, #lo_addr(_Set_Index+0)
MOVT	R0, #hi_addr(_Set_Index+0)
BL	_TFT_Set_Active+0
;PerfectEnvironment_driver.c,68 :: 		TFT_Init_SSD1963_Board_43( 480, 272);
MOVW	R1, #272
MOVW	R0, #480
BL	_TFT_Init_SSD1963_Board_43+0
;PerfectEnvironment_driver.c,70 :: 		TFT_Set_DBC_SSD1963(255);
MOVS	R0, #255
BL	_TFT_Set_DBC_SSD1963+0
;PerfectEnvironment_driver.c,72 :: 		PenDown = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,73 :: 		PressedObject = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PressedObject+0)
MOVT	R0, #hi_addr(_PressedObject+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,74 :: 		PressedObjectType = -1;
MOVW	R1, #65535
SXTH	R1, R1
MOVW	R0, #lo_addr(_PressedObjectType+0)
MOVT	R0, #hi_addr(_PressedObjectType+0)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,75 :: 		}
L_end_InitializeTouchPanel:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of PerfectEnvironment_driver_InitializeTouchPanel
PerfectEnvironment_driver_InitializeObjects:
;PerfectEnvironment_driver.c,153 :: 		static void InitializeObjects( ) {
;PerfectEnvironment_driver.c,154 :: 		Screen1.Color                     = 0x5AEB;
MOVW	R1, #23275
MOVW	R0, #lo_addr(_Screen1+0)
MOVT	R0, #hi_addr(_Screen1+0)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,155 :: 		Screen1.Width                     = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Screen1+2)
MOVT	R0, #hi_addr(_Screen1+2)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,156 :: 		Screen1.Height                    = 272;
MOVW	R1, #272
MOVW	R0, #lo_addr(_Screen1+4)
MOVT	R0, #hi_addr(_Screen1+4)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,157 :: 		Screen1.ButtonsCount              = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Screen1+8)
MOVT	R0, #hi_addr(_Screen1+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,158 :: 		Screen1.Buttons                   = Screen1_Buttons;
MOVW	R1, #lo_addr(_Screen1_Buttons+0)
MOVT	R1, #hi_addr(_Screen1_Buttons+0)
MOVW	R0, #lo_addr(_Screen1+12)
MOVT	R0, #hi_addr(_Screen1+12)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,159 :: 		Screen1.LabelsCount               = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_Screen1+16)
MOVT	R0, #hi_addr(_Screen1+16)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,160 :: 		Screen1.Labels                    = Screen1_Labels;
MOVW	R1, #lo_addr(_Screen1_Labels+0)
MOVT	R1, #hi_addr(_Screen1_Labels+0)
MOVW	R0, #lo_addr(_Screen1+20)
MOVT	R0, #hi_addr(_Screen1+20)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,161 :: 		Screen1.ImagesCount               = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_Screen1+24)
MOVT	R0, #hi_addr(_Screen1+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,162 :: 		Screen1.Images                    = Screen1_Images;
MOVW	R1, #lo_addr(_Screen1_Images+0)
MOVT	R1, #hi_addr(_Screen1_Images+0)
MOVW	R0, #lo_addr(_Screen1+28)
MOVT	R0, #hi_addr(_Screen1+28)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,163 :: 		Screen1.ObjectsCount              = 20;
MOVS	R1, #20
MOVW	R0, #lo_addr(_Screen1+6)
MOVT	R0, #hi_addr(_Screen1+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,164 :: 		Screen1.OnSwipeUpPtr    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+40)
MOVT	R0, #hi_addr(_Screen1+40)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,165 :: 		Screen1.OnSwipeDownPtr  = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+44)
MOVT	R0, #hi_addr(_Screen1+44)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,166 :: 		Screen1.OnSwipeLeftPtr  = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+32)
MOVT	R0, #hi_addr(_Screen1+32)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,167 :: 		Screen1.OnSwipeRightPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+36)
MOVT	R0, #hi_addr(_Screen1+36)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,168 :: 		Screen1.OnZoomInPtr     = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+48)
MOVT	R0, #hi_addr(_Screen1+48)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,169 :: 		Screen1.OnZoomOutPtr    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Screen1+52)
MOVT	R0, #hi_addr(_Screen1+52)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,172 :: 		Image10.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image10+0)
MOVT	R0, #hi_addr(_Image10+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,173 :: 		Image10.Order           = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image10+4)
MOVT	R0, #hi_addr(_Image10+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,174 :: 		Image10.Left            = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image10+6)
MOVT	R0, #hi_addr(_Image10+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,175 :: 		Image10.Top             = 203;
MOVS	R1, #203
MOVW	R0, #lo_addr(_Image10+8)
MOVT	R0, #hi_addr(_Image10+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,176 :: 		Image10.Width           = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Image10+10)
MOVT	R0, #hi_addr(_Image10+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,177 :: 		Image10.Height          = 69;
MOVS	R1, #69
MOVW	R0, #lo_addr(_Image10+12)
MOVT	R0, #hi_addr(_Image10+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,178 :: 		Image10.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image10+22)
MOVT	R0, #hi_addr(_Image10+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,179 :: 		Image10.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image10+23)
MOVT	R0, #hi_addr(_Image10+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,180 :: 		Image10.Picture_Name    = water2_jpg;
MOVW	R1, #lo_addr(_water2_jpg+0)
MOVT	R1, #hi_addr(_water2_jpg+0)
MOVW	R0, #lo_addr(_Image10+16)
MOVT	R0, #hi_addr(_Image10+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,181 :: 		Image10.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image10+20)
MOVT	R0, #hi_addr(_Image10+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,182 :: 		Image10.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image10+21)
MOVT	R0, #hi_addr(_Image10+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,184 :: 		Image9.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image9+0)
MOVT	R0, #hi_addr(_Image9+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,185 :: 		Image9.Order           = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image9+4)
MOVT	R0, #hi_addr(_Image9+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,186 :: 		Image9.Left            = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image9+6)
MOVT	R0, #hi_addr(_Image9+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,187 :: 		Image9.Top             = 203;
MOVS	R1, #203
MOVW	R0, #lo_addr(_Image9+8)
MOVT	R0, #hi_addr(_Image9+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,188 :: 		Image9.Width           = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Image9+10)
MOVT	R0, #hi_addr(_Image9+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,189 :: 		Image9.Height          = 69;
MOVS	R1, #69
MOVW	R0, #lo_addr(_Image9+12)
MOVT	R0, #hi_addr(_Image9+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,190 :: 		Image9.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image9+22)
MOVT	R0, #hi_addr(_Image9+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,191 :: 		Image9.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image9+23)
MOVT	R0, #hi_addr(_Image9+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,192 :: 		Image9.Picture_Name    = water1_jpg;
MOVW	R1, #lo_addr(_water1_jpg+0)
MOVT	R1, #hi_addr(_water1_jpg+0)
MOVW	R0, #lo_addr(_Image9+16)
MOVT	R0, #hi_addr(_Image9+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,193 :: 		Image9.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image9+20)
MOVT	R0, #hi_addr(_Image9+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,194 :: 		Image9.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image9+21)
MOVT	R0, #hi_addr(_Image9+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,196 :: 		Image11.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image11+0)
MOVT	R0, #hi_addr(_Image11+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,197 :: 		Image11.Order           = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_Image11+4)
MOVT	R0, #hi_addr(_Image11+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,198 :: 		Image11.Left            = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image11+6)
MOVT	R0, #hi_addr(_Image11+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,199 :: 		Image11.Top             = 203;
MOVS	R1, #203
MOVW	R0, #lo_addr(_Image11+8)
MOVT	R0, #hi_addr(_Image11+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,200 :: 		Image11.Width           = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Image11+10)
MOVT	R0, #hi_addr(_Image11+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,201 :: 		Image11.Height          = 69;
MOVS	R1, #69
MOVW	R0, #lo_addr(_Image11+12)
MOVT	R0, #hi_addr(_Image11+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,202 :: 		Image11.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image11+22)
MOVT	R0, #hi_addr(_Image11+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,203 :: 		Image11.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image11+23)
MOVT	R0, #hi_addr(_Image11+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,204 :: 		Image11.Picture_Name    = water3_jpg;
MOVW	R1, #lo_addr(_water3_jpg+0)
MOVT	R1, #hi_addr(_water3_jpg+0)
MOVW	R0, #lo_addr(_Image11+16)
MOVT	R0, #hi_addr(_Image11+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,205 :: 		Image11.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image11+20)
MOVT	R0, #hi_addr(_Image11+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,206 :: 		Image11.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image11+21)
MOVT	R0, #hi_addr(_Image11+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,208 :: 		Image1.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image1+0)
MOVT	R0, #hi_addr(_Image1+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,209 :: 		Image1.Order           = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_Image1+4)
MOVT	R0, #hi_addr(_Image1+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,210 :: 		Image1.Left            = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image1+6)
MOVT	R0, #hi_addr(_Image1+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,211 :: 		Image1.Top             = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image1+8)
MOVT	R0, #hi_addr(_Image1+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,212 :: 		Image1.Width           = 480;
MOVW	R1, #480
MOVW	R0, #lo_addr(_Image1+10)
MOVT	R0, #hi_addr(_Image1+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,213 :: 		Image1.Height          = 272;
MOVW	R1, #272
MOVW	R0, #lo_addr(_Image1+12)
MOVT	R0, #hi_addr(_Image1+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,214 :: 		Image1.Picture_Type    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image1+22)
MOVT	R0, #hi_addr(_Image1+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,215 :: 		Image1.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image1+23)
MOVT	R0, #hi_addr(_Image1+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,216 :: 		Image1.Picture_Name    = screen_bmp;
MOVW	R1, #lo_addr(_screen_bmp+0)
MOVT	R1, #hi_addr(_screen_bmp+0)
MOVW	R0, #lo_addr(_Image1+16)
MOVT	R0, #hi_addr(_Image1+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,217 :: 		Image1.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image1+20)
MOVT	R0, #hi_addr(_Image1+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,218 :: 		Image1.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image1+21)
MOVT	R0, #hi_addr(_Image1+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,220 :: 		Image8.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image8+0)
MOVT	R0, #hi_addr(_Image8+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,221 :: 		Image8.Order           = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_Image8+4)
MOVT	R0, #hi_addr(_Image8+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,222 :: 		Image8.Left            = 367;
MOVW	R1, #367
MOVW	R0, #lo_addr(_Image8+6)
MOVT	R0, #hi_addr(_Image8+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,223 :: 		Image8.Top             = 155;
MOVS	R1, #155
MOVW	R0, #lo_addr(_Image8+8)
MOVT	R0, #hi_addr(_Image8+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,224 :: 		Image8.Width           = 79;
MOVS	R1, #79
MOVW	R0, #lo_addr(_Image8+10)
MOVT	R0, #hi_addr(_Image8+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,225 :: 		Image8.Height          = 26;
MOVS	R1, #26
MOVW	R0, #lo_addr(_Image8+12)
MOVT	R0, #hi_addr(_Image8+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,226 :: 		Image8.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image8+22)
MOVT	R0, #hi_addr(_Image8+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,227 :: 		Image8.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image8+23)
MOVT	R0, #hi_addr(_Image8+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,228 :: 		Image8.Picture_Name    = tv_jpg;
MOVW	R1, #lo_addr(_tv_jpg+0)
MOVT	R1, #hi_addr(_tv_jpg+0)
MOVW	R0, #lo_addr(_Image8+16)
MOVT	R0, #hi_addr(_Image8+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,229 :: 		Image8.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image8+20)
MOVT	R0, #hi_addr(_Image8+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,230 :: 		Image8.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image8+21)
MOVT	R0, #hi_addr(_Image8+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,232 :: 		Image7.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image7+0)
MOVT	R0, #hi_addr(_Image7+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,233 :: 		Image7.Order           = 5;
MOVS	R1, #5
MOVW	R0, #lo_addr(_Image7+4)
MOVT	R0, #hi_addr(_Image7+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,234 :: 		Image7.Left            = 255;
MOVS	R1, #255
MOVW	R0, #lo_addr(_Image7+6)
MOVT	R0, #hi_addr(_Image7+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,235 :: 		Image7.Top             = 155;
MOVS	R1, #155
MOVW	R0, #lo_addr(_Image7+8)
MOVT	R0, #hi_addr(_Image7+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,236 :: 		Image7.Width           = 77;
MOVS	R1, #77
MOVW	R0, #lo_addr(_Image7+10)
MOVT	R0, #hi_addr(_Image7+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,237 :: 		Image7.Height          = 27;
MOVS	R1, #27
MOVW	R0, #lo_addr(_Image7+12)
MOVT	R0, #hi_addr(_Image7+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,238 :: 		Image7.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image7+22)
MOVT	R0, #hi_addr(_Image7+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,239 :: 		Image7.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image7+23)
MOVT	R0, #hi_addr(_Image7+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,240 :: 		Image7.Picture_Name    = c_jpg;
MOVW	R1, #lo_addr(_c_jpg+0)
MOVT	R1, #hi_addr(_c_jpg+0)
MOVW	R0, #lo_addr(_Image7+16)
MOVT	R0, #hi_addr(_Image7+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,241 :: 		Image7.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image7+20)
MOVT	R0, #hi_addr(_Image7+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,242 :: 		Image7.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image7+21)
MOVT	R0, #hi_addr(_Image7+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,244 :: 		Image6.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image6+0)
MOVT	R0, #hi_addr(_Image6+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,245 :: 		Image6.Order           = 6;
MOVS	R1, #6
MOVW	R0, #lo_addr(_Image6+4)
MOVT	R0, #hi_addr(_Image6+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,246 :: 		Image6.Left            = 128;
MOVS	R1, #128
MOVW	R0, #lo_addr(_Image6+6)
MOVT	R0, #hi_addr(_Image6+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,247 :: 		Image6.Top             = 157;
MOVS	R1, #157
MOVW	R0, #lo_addr(_Image6+8)
MOVT	R0, #hi_addr(_Image6+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,248 :: 		Image6.Width           = 110;
MOVS	R1, #110
MOVW	R0, #lo_addr(_Image6+10)
MOVT	R0, #hi_addr(_Image6+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,249 :: 		Image6.Height          = 26;
MOVS	R1, #26
MOVW	R0, #lo_addr(_Image6+12)
MOVT	R0, #hi_addr(_Image6+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,250 :: 		Image6.Picture_Type    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Image6+22)
MOVT	R0, #hi_addr(_Image6+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,251 :: 		Image6.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image6+23)
MOVT	R0, #hi_addr(_Image6+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,252 :: 		Image6.Picture_Name    = u_bmp;
MOVW	R1, #lo_addr(_u_bmp+0)
MOVT	R1, #hi_addr(_u_bmp+0)
MOVW	R0, #lo_addr(_Image6+16)
MOVT	R0, #hi_addr(_Image6+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,253 :: 		Image6.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image6+20)
MOVT	R0, #hi_addr(_Image6+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,254 :: 		Image6.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image6+21)
MOVT	R0, #hi_addr(_Image6+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,256 :: 		Image5.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image5+0)
MOVT	R0, #hi_addr(_Image5+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,257 :: 		Image5.Order           = 7;
MOVS	R1, #7
MOVW	R0, #lo_addr(_Image5+4)
MOVT	R0, #hi_addr(_Image5+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,258 :: 		Image5.Left            = 40;
MOVS	R1, #40
MOVW	R0, #lo_addr(_Image5+6)
MOVT	R0, #hi_addr(_Image5+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,259 :: 		Image5.Top             = 154;
MOVS	R1, #154
MOVW	R0, #lo_addr(_Image5+8)
MOVT	R0, #hi_addr(_Image5+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,260 :: 		Image5.Width           = 84;
MOVS	R1, #84
MOVW	R0, #lo_addr(_Image5+10)
MOVT	R0, #hi_addr(_Image5+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,261 :: 		Image5.Height          = 27;
MOVS	R1, #27
MOVW	R0, #lo_addr(_Image5+12)
MOVT	R0, #hi_addr(_Image5+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,262 :: 		Image5.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image5+22)
MOVT	R0, #hi_addr(_Image5+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,263 :: 		Image5.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image5+23)
MOVT	R0, #hi_addr(_Image5+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,264 :: 		Image5.Picture_Name    = p_jpg;
MOVW	R1, #lo_addr(_p_jpg+0)
MOVT	R1, #hi_addr(_p_jpg+0)
MOVW	R0, #lo_addr(_Image5+16)
MOVT	R0, #hi_addr(_Image5+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,265 :: 		Image5.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image5+20)
MOVT	R0, #hi_addr(_Image5+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,266 :: 		Image5.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image5+21)
MOVT	R0, #hi_addr(_Image5+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,268 :: 		Image3.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image3+0)
MOVT	R0, #hi_addr(_Image3+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,269 :: 		Image3.Order           = 8;
MOVS	R1, #8
MOVW	R0, #lo_addr(_Image3+4)
MOVT	R0, #hi_addr(_Image3+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,270 :: 		Image3.Left            = 234;
MOVS	R1, #234
MOVW	R0, #lo_addr(_Image3+6)
MOVT	R0, #hi_addr(_Image3+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,271 :: 		Image3.Top             = 40;
MOVS	R1, #40
MOVW	R0, #lo_addr(_Image3+8)
MOVT	R0, #hi_addr(_Image3+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,272 :: 		Image3.Width           = 56;
MOVS	R1, #56
MOVW	R0, #lo_addr(_Image3+10)
MOVT	R0, #hi_addr(_Image3+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,273 :: 		Image3.Height          = 45;
MOVS	R1, #45
MOVW	R0, #lo_addr(_Image3+12)
MOVT	R0, #hi_addr(_Image3+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,274 :: 		Image3.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image3+22)
MOVT	R0, #hi_addr(_Image3+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,275 :: 		Image3.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image3+23)
MOVT	R0, #hi_addr(_Image3+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,276 :: 		Image3.Picture_Name    = h_jpg;
MOVW	R1, #lo_addr(_h_jpg+0)
MOVT	R1, #hi_addr(_h_jpg+0)
MOVW	R0, #lo_addr(_Image3+16)
MOVT	R0, #hi_addr(_Image3+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,277 :: 		Image3.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image3+20)
MOVT	R0, #hi_addr(_Image3+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,278 :: 		Image3.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image3+21)
MOVT	R0, #hi_addr(_Image3+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,280 :: 		Image4.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image4+0)
MOVT	R0, #hi_addr(_Image4+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,281 :: 		Image4.Order           = 9;
MOVS	R1, #9
MOVW	R0, #lo_addr(_Image4+4)
MOVT	R0, #hi_addr(_Image4+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,282 :: 		Image4.Left            = 381;
MOVW	R1, #381
MOVW	R0, #lo_addr(_Image4+6)
MOVT	R0, #hi_addr(_Image4+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,283 :: 		Image4.Top             = 40;
MOVS	R1, #40
MOVW	R0, #lo_addr(_Image4+8)
MOVT	R0, #hi_addr(_Image4+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,284 :: 		Image4.Width           = 71;
MOVS	R1, #71
MOVW	R0, #lo_addr(_Image4+10)
MOVT	R0, #hi_addr(_Image4+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,285 :: 		Image4.Height          = 47;
MOVS	R1, #47
MOVW	R0, #lo_addr(_Image4+12)
MOVT	R0, #hi_addr(_Image4+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,286 :: 		Image4.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image4+22)
MOVT	R0, #hi_addr(_Image4+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,287 :: 		Image4.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image4+23)
MOVT	R0, #hi_addr(_Image4+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,288 :: 		Image4.Picture_Name    = a_jpg;
MOVW	R1, #lo_addr(_a_jpg+0)
MOVT	R1, #hi_addr(_a_jpg+0)
MOVW	R0, #lo_addr(_Image4+16)
MOVT	R0, #hi_addr(_Image4+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,289 :: 		Image4.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image4+20)
MOVT	R0, #hi_addr(_Image4+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,290 :: 		Image4.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image4+21)
MOVT	R0, #hi_addr(_Image4+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,292 :: 		Image2.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Image2+0)
MOVT	R0, #hi_addr(_Image2+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,293 :: 		Image2.Order           = 10;
MOVS	R1, #10
MOVW	R0, #lo_addr(_Image2+4)
MOVT	R0, #hi_addr(_Image2+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,294 :: 		Image2.Left            = 74;
MOVS	R1, #74
MOVW	R0, #lo_addr(_Image2+6)
MOVT	R0, #hi_addr(_Image2+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,295 :: 		Image2.Top             = 40;
MOVS	R1, #40
MOVW	R0, #lo_addr(_Image2+8)
MOVT	R0, #hi_addr(_Image2+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,296 :: 		Image2.Width           = 52;
MOVS	R1, #52
MOVW	R0, #lo_addr(_Image2+10)
MOVT	R0, #hi_addr(_Image2+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,297 :: 		Image2.Height          = 41;
MOVS	R1, #41
MOVW	R0, #lo_addr(_Image2+12)
MOVT	R0, #hi_addr(_Image2+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,298 :: 		Image2.Picture_Type    = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image2+22)
MOVT	R0, #hi_addr(_Image2+22)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,299 :: 		Image2.Picture_Ratio   = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image2+23)
MOVT	R0, #hi_addr(_Image2+23)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,300 :: 		Image2.Picture_Name    = t_jpg;
MOVW	R1, #lo_addr(_t_jpg+0)
MOVT	R1, #hi_addr(_t_jpg+0)
MOVW	R0, #lo_addr(_Image2+16)
MOVT	R0, #hi_addr(_Image2+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,301 :: 		Image2.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image2+20)
MOVT	R0, #hi_addr(_Image2+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,302 :: 		Image2.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Image2+21)
MOVT	R0, #hi_addr(_Image2+21)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,304 :: 		Label7.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label7+0)
MOVT	R0, #hi_addr(_Label7+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,305 :: 		Label7.Order           = 11;
MOVS	R1, #11
MOVW	R0, #lo_addr(_Label7+4)
MOVT	R0, #hi_addr(_Label7+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,306 :: 		Label7.Left            = 74;
MOVS	R1, #74
MOVW	R0, #lo_addr(_Label7+6)
MOVT	R0, #hi_addr(_Label7+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,307 :: 		Label7.Top             = 47;
MOVS	R1, #47
MOVW	R0, #lo_addr(_Label7+8)
MOVT	R0, #hi_addr(_Label7+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,308 :: 		Label7.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label7+10)
MOVT	R0, #hi_addr(_Label7+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,309 :: 		Label7.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label7+12)
MOVT	R0, #hi_addr(_Label7+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,310 :: 		Label7.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label7+27)
MOVT	R0, #hi_addr(_Label7+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,311 :: 		Label7.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label7+28)
MOVT	R0, #hi_addr(_Label7+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,312 :: 		Label7.Caption         = Label7_Caption;
MOVW	R1, #lo_addr(_Label7_Caption+0)
MOVT	R1, #hi_addr(_Label7_Caption+0)
MOVW	R0, #lo_addr(_Label7+16)
MOVT	R0, #hi_addr(_Label7+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,313 :: 		Label7.FontName        = Tahoma29x29_Bold;
MOVW	R2, #lo_addr(_Tahoma29x29_Bold+0)
MOVT	R2, #hi_addr(_Tahoma29x29_Bold+0)
MOVW	R0, #lo_addr(_Label7+20)
MOVT	R0, #hi_addr(_Label7+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,314 :: 		Label7.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label7+24)
MOVT	R0, #hi_addr(_Label7+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,315 :: 		Label7.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label7+26)
MOVT	R0, #hi_addr(_Label7+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,317 :: 		Label8.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label8+0)
MOVT	R0, #hi_addr(_Label8+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,318 :: 		Label8.Order           = 12;
MOVS	R1, #12
MOVW	R0, #lo_addr(_Label8+4)
MOVT	R0, #hi_addr(_Label8+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,319 :: 		Label8.Left            = 235;
MOVS	R1, #235
MOVW	R0, #lo_addr(_Label8+6)
MOVT	R0, #hi_addr(_Label8+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,320 :: 		Label8.Top             = 47;
MOVS	R1, #47
MOVW	R0, #lo_addr(_Label8+8)
MOVT	R0, #hi_addr(_Label8+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,321 :: 		Label8.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label8+10)
MOVT	R0, #hi_addr(_Label8+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,322 :: 		Label8.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label8+12)
MOVT	R0, #hi_addr(_Label8+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,323 :: 		Label8.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label8+27)
MOVT	R0, #hi_addr(_Label8+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,324 :: 		Label8.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label8+28)
MOVT	R0, #hi_addr(_Label8+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,325 :: 		Label8.Caption         = Label8_Caption;
MOVW	R1, #lo_addr(_Label8_Caption+0)
MOVT	R1, #hi_addr(_Label8_Caption+0)
MOVW	R0, #lo_addr(_Label8+16)
MOVT	R0, #hi_addr(_Label8+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,326 :: 		Label8.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label8+20)
MOVT	R0, #hi_addr(_Label8+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,327 :: 		Label8.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label8+24)
MOVT	R0, #hi_addr(_Label8+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,328 :: 		Label8.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label8+26)
MOVT	R0, #hi_addr(_Label8+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,330 :: 		Label9.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label9+0)
MOVT	R0, #hi_addr(_Label9+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,331 :: 		Label9.Order           = 13;
MOVS	R1, #13
MOVW	R0, #lo_addr(_Label9+4)
MOVT	R0, #hi_addr(_Label9+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,332 :: 		Label9.Left            = 381;
MOVW	R1, #381
MOVW	R0, #lo_addr(_Label9+6)
MOVT	R0, #hi_addr(_Label9+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,333 :: 		Label9.Top             = 47;
MOVS	R1, #47
MOVW	R0, #lo_addr(_Label9+8)
MOVT	R0, #hi_addr(_Label9+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,334 :: 		Label9.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label9+10)
MOVT	R0, #hi_addr(_Label9+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,335 :: 		Label9.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label9+12)
MOVT	R0, #hi_addr(_Label9+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,336 :: 		Label9.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label9+27)
MOVT	R0, #hi_addr(_Label9+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,337 :: 		Label9.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label9+28)
MOVT	R0, #hi_addr(_Label9+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,338 :: 		Label9.Caption         = Label9_Caption;
MOVW	R1, #lo_addr(_Label9_Caption+0)
MOVT	R1, #hi_addr(_Label9_Caption+0)
MOVW	R0, #lo_addr(_Label9+16)
MOVT	R0, #hi_addr(_Label9+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,339 :: 		Label9.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label9+20)
MOVT	R0, #hi_addr(_Label9+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,340 :: 		Label9.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label9+24)
MOVT	R0, #hi_addr(_Label9+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,341 :: 		Label9.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label9+26)
MOVT	R0, #hi_addr(_Label9+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,343 :: 		Label10.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label10+0)
MOVT	R0, #hi_addr(_Label10+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,344 :: 		Label10.Order           = 14;
MOVS	R1, #14
MOVW	R0, #lo_addr(_Label10+4)
MOVT	R0, #hi_addr(_Label10+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,345 :: 		Label10.Left            = 40;
MOVS	R1, #40
MOVW	R0, #lo_addr(_Label10+6)
MOVT	R0, #hi_addr(_Label10+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,346 :: 		Label10.Top             = 153;
MOVS	R1, #153
MOVW	R0, #lo_addr(_Label10+8)
MOVT	R0, #hi_addr(_Label10+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,347 :: 		Label10.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label10+10)
MOVT	R0, #hi_addr(_Label10+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,348 :: 		Label10.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label10+12)
MOVT	R0, #hi_addr(_Label10+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,349 :: 		Label10.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label10+27)
MOVT	R0, #hi_addr(_Label10+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,350 :: 		Label10.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label10+28)
MOVT	R0, #hi_addr(_Label10+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,351 :: 		Label10.Caption         = Label10_Caption;
MOVW	R1, #lo_addr(_Label10_Caption+0)
MOVT	R1, #hi_addr(_Label10_Caption+0)
MOVW	R0, #lo_addr(_Label10+16)
MOVT	R0, #hi_addr(_Label10+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,352 :: 		Label10.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label10+20)
MOVT	R0, #hi_addr(_Label10+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,353 :: 		Label10.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label10+24)
MOVT	R0, #hi_addr(_Label10+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,354 :: 		Label10.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label10+26)
MOVT	R0, #hi_addr(_Label10+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,356 :: 		Label11.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label11+0)
MOVT	R0, #hi_addr(_Label11+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,357 :: 		Label11.Order           = 15;
MOVS	R1, #15
MOVW	R0, #lo_addr(_Label11+4)
MOVT	R0, #hi_addr(_Label11+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,358 :: 		Label11.Left            = 153;
MOVS	R1, #153
MOVW	R0, #lo_addr(_Label11+6)
MOVT	R0, #hi_addr(_Label11+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,359 :: 		Label11.Top             = 153;
MOVS	R1, #153
MOVW	R0, #lo_addr(_Label11+8)
MOVT	R0, #hi_addr(_Label11+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,360 :: 		Label11.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label11+10)
MOVT	R0, #hi_addr(_Label11+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,361 :: 		Label11.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label11+12)
MOVT	R0, #hi_addr(_Label11+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,362 :: 		Label11.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label11+27)
MOVT	R0, #hi_addr(_Label11+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,363 :: 		Label11.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label11+28)
MOVT	R0, #hi_addr(_Label11+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,364 :: 		Label11.Caption         = Label11_Caption;
MOVW	R1, #lo_addr(_Label11_Caption+0)
MOVT	R1, #hi_addr(_Label11_Caption+0)
MOVW	R0, #lo_addr(_Label11+16)
MOVT	R0, #hi_addr(_Label11+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,365 :: 		Label11.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label11+20)
MOVT	R0, #hi_addr(_Label11+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,366 :: 		Label11.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label11+24)
MOVT	R0, #hi_addr(_Label11+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,367 :: 		Label11.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label11+26)
MOVT	R0, #hi_addr(_Label11+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,369 :: 		Label12.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label12+0)
MOVT	R0, #hi_addr(_Label12+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,370 :: 		Label12.Order           = 16;
MOVS	R1, #16
MOVW	R0, #lo_addr(_Label12+4)
MOVT	R0, #hi_addr(_Label12+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,371 :: 		Label12.Left            = 262;
MOVW	R1, #262
MOVW	R0, #lo_addr(_Label12+6)
MOVT	R0, #hi_addr(_Label12+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,372 :: 		Label12.Top             = 153;
MOVS	R1, #153
MOVW	R0, #lo_addr(_Label12+8)
MOVT	R0, #hi_addr(_Label12+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,373 :: 		Label12.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label12+10)
MOVT	R0, #hi_addr(_Label12+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,374 :: 		Label12.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label12+12)
MOVT	R0, #hi_addr(_Label12+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,375 :: 		Label12.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label12+27)
MOVT	R0, #hi_addr(_Label12+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,376 :: 		Label12.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label12+28)
MOVT	R0, #hi_addr(_Label12+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,377 :: 		Label12.Caption         = Label12_Caption;
MOVW	R1, #lo_addr(_Label12_Caption+0)
MOVT	R1, #hi_addr(_Label12_Caption+0)
MOVW	R0, #lo_addr(_Label12+16)
MOVT	R0, #hi_addr(_Label12+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,378 :: 		Label12.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label12+20)
MOVT	R0, #hi_addr(_Label12+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,379 :: 		Label12.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label12+24)
MOVT	R0, #hi_addr(_Label12+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,380 :: 		Label12.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label12+26)
MOVT	R0, #hi_addr(_Label12+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,382 :: 		Label13.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label13+0)
MOVT	R0, #hi_addr(_Label13+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,383 :: 		Label13.Order           = 17;
MOVS	R1, #17
MOVW	R0, #lo_addr(_Label13+4)
MOVT	R0, #hi_addr(_Label13+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,384 :: 		Label13.Left            = 373;
MOVW	R1, #373
MOVW	R0, #lo_addr(_Label13+6)
MOVT	R0, #hi_addr(_Label13+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,385 :: 		Label13.Top             = 153;
MOVS	R1, #153
MOVW	R0, #lo_addr(_Label13+8)
MOVT	R0, #hi_addr(_Label13+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,386 :: 		Label13.Width           = 24;
MOVS	R1, #24
MOVW	R0, #lo_addr(_Label13+10)
MOVT	R0, #hi_addr(_Label13+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,387 :: 		Label13.Height          = 32;
MOVS	R1, #32
MOVW	R0, #lo_addr(_Label13+12)
MOVT	R0, #hi_addr(_Label13+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,388 :: 		Label13.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label13+27)
MOVT	R0, #hi_addr(_Label13+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,389 :: 		Label13.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label13+28)
MOVT	R0, #hi_addr(_Label13+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,390 :: 		Label13.Caption         = Label13_Caption;
MOVW	R1, #lo_addr(_Label13_Caption+0)
MOVT	R1, #hi_addr(_Label13_Caption+0)
MOVW	R0, #lo_addr(_Label13+16)
MOVT	R0, #hi_addr(_Label13+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,391 :: 		Label13.FontName        = Tahoma29x29_Bold;
MOVW	R0, #lo_addr(_Label13+20)
MOVT	R0, #hi_addr(_Label13+20)
STR	R2, [R0, #0]
;PerfectEnvironment_driver.c,392 :: 		Label13.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label13+24)
MOVT	R0, #hi_addr(_Label13+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,393 :: 		Label13.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label13+26)
MOVT	R0, #hi_addr(_Label13+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,395 :: 		Button1.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Button1+0)
MOVT	R0, #hi_addr(_Button1+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,396 :: 		Button1.Order           = 18;
MOVS	R1, #18
MOVW	R0, #lo_addr(_Button1+4)
MOVT	R0, #hi_addr(_Button1+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,397 :: 		Button1.Left            = 286;
MOVW	R1, #286
MOVW	R0, #lo_addr(_Button1+6)
MOVT	R0, #hi_addr(_Button1+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,398 :: 		Button1.Top             = 204;
MOVS	R1, #204
MOVW	R0, #lo_addr(_Button1+8)
MOVT	R0, #hi_addr(_Button1+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,399 :: 		Button1.Width           = 71;
MOVS	R1, #71
MOVW	R0, #lo_addr(_Button1+10)
MOVT	R0, #hi_addr(_Button1+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,400 :: 		Button1.Height          = 64;
MOVS	R1, #64
MOVW	R0, #lo_addr(_Button1+12)
MOVT	R0, #hi_addr(_Button1+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,401 :: 		Button1.Pen_Width       = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+14)
MOVT	R0, #hi_addr(_Button1+14)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,402 :: 		Button1.Pen_Color       = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Button1+16)
MOVT	R0, #hi_addr(_Button1+16)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,403 :: 		Button1.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+18)
MOVT	R0, #hi_addr(_Button1+18)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,404 :: 		Button1.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+19)
MOVT	R0, #hi_addr(_Button1+19)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,405 :: 		Button1.Transparent     = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+20)
MOVT	R0, #hi_addr(_Button1+20)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,406 :: 		Button1.Caption         = Button1_Caption;
MOVW	R1, #lo_addr(_Button1_Caption+0)
MOVT	R1, #hi_addr(_Button1_Caption+0)
MOVW	R0, #lo_addr(_Button1+24)
MOVT	R0, #hi_addr(_Button1+24)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,407 :: 		Button1.TextAlign       = _taCenter;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+28)
MOVT	R0, #hi_addr(_Button1+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,408 :: 		Button1.TextAlignVertical= _tavMiddle;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+29)
MOVT	R0, #hi_addr(_Button1+29)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,409 :: 		Button1.FontName        = Tahoma11x13_Regular;
MOVW	R1, #lo_addr(_Tahoma11x13_Regular+0)
MOVT	R1, #hi_addr(_Tahoma11x13_Regular+0)
MOVW	R0, #lo_addr(_Button1+32)
MOVT	R0, #hi_addr(_Button1+32)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,410 :: 		Button1.PressColEnabled = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+48)
MOVT	R0, #hi_addr(_Button1+48)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,411 :: 		Button1.Font_Color      = 0x0000;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+36)
MOVT	R0, #hi_addr(_Button1+36)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,412 :: 		Button1.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+38)
MOVT	R0, #hi_addr(_Button1+38)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,413 :: 		Button1.Gradient        = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Button1+39)
MOVT	R0, #hi_addr(_Button1+39)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,414 :: 		Button1.Gradient_Orientation = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Button1+40)
MOVT	R0, #hi_addr(_Button1+40)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,415 :: 		Button1.Gradient_Start_Color = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Button1+42)
MOVT	R0, #hi_addr(_Button1+42)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,416 :: 		Button1.Gradient_End_Color = 0xC618;
MOVW	R1, #50712
MOVW	R0, #lo_addr(_Button1+44)
MOVT	R0, #hi_addr(_Button1+44)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,417 :: 		Button1.Color           = 0xC618;
MOVW	R1, #50712
MOVW	R0, #lo_addr(_Button1+46)
MOVT	R0, #hi_addr(_Button1+46)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,418 :: 		Button1.Press_Color     = 0xE71C;
MOVW	R1, #59164
MOVW	R0, #lo_addr(_Button1+50)
MOVT	R0, #hi_addr(_Button1+50)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,419 :: 		Button1.OnClickPtr      = Button1OnClick;
MOVW	R1, #lo_addr(_Button1OnClick+0)
MOVT	R1, #hi_addr(_Button1OnClick+0)
MOVW	R0, #lo_addr(_Button1+60)
MOVT	R0, #hi_addr(_Button1+60)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,421 :: 		Label14.OwnerScreen     = &Screen1;
MOVW	R1, #lo_addr(_Screen1+0)
MOVT	R1, #hi_addr(_Screen1+0)
MOVW	R0, #lo_addr(_Label14+0)
MOVT	R0, #hi_addr(_Label14+0)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,422 :: 		Label14.Order           = 19;
MOVS	R1, #19
MOVW	R0, #lo_addr(_Label14+4)
MOVT	R0, #hi_addr(_Label14+4)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,423 :: 		Label14.Left            = 364;
MOVW	R1, #364
MOVW	R0, #lo_addr(_Label14+6)
MOVT	R0, #hi_addr(_Label14+6)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,424 :: 		Label14.Top             = 225;
MOVS	R1, #225
MOVW	R0, #lo_addr(_Label14+8)
MOVT	R0, #hi_addr(_Label14+8)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,425 :: 		Label14.Width           = 44;
MOVS	R1, #44
MOVW	R0, #lo_addr(_Label14+10)
MOVT	R0, #hi_addr(_Label14+10)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,426 :: 		Label14.Height          = 25;
MOVS	R1, #25
MOVW	R0, #lo_addr(_Label14+12)
MOVT	R0, #hi_addr(_Label14+12)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,427 :: 		Label14.Visible         = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label14+27)
MOVT	R0, #hi_addr(_Label14+27)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,428 :: 		Label14.Active          = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Label14+28)
MOVT	R0, #hi_addr(_Label14+28)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,429 :: 		Label14.Caption         = Label14_Caption;
MOVW	R1, #lo_addr(_Label14_Caption+0)
MOVT	R1, #hi_addr(_Label14_Caption+0)
MOVW	R0, #lo_addr(_Label14+16)
MOVT	R0, #hi_addr(_Label14+16)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,430 :: 		Label14.FontName        = Tahoma23x23_Bold;
MOVW	R1, #lo_addr(_Tahoma23x23_Bold+0)
MOVT	R1, #hi_addr(_Tahoma23x23_Bold+0)
MOVW	R0, #lo_addr(_Label14+20)
MOVT	R0, #hi_addr(_Label14+20)
STR	R1, [R0, #0]
;PerfectEnvironment_driver.c,431 :: 		Label14.Font_Color      = 0xFFFF;
MOVW	R1, #65535
MOVW	R0, #lo_addr(_Label14+24)
MOVT	R0, #hi_addr(_Label14+24)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,432 :: 		Label14.VerticalText    = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_Label14+26)
MOVT	R0, #hi_addr(_Label14+26)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,433 :: 		}
L_end_InitializeObjects:
BX	LR
; end of PerfectEnvironment_driver_InitializeObjects
PerfectEnvironment_driver_IsInsideObject:
;PerfectEnvironment_driver.c,435 :: 		static char IsInsideObject ( unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height ) { // static
; Top start address is: 12 (R3)
; Left start address is: 8 (R2)
; Y start address is: 4 (R1)
; X start address is: 0 (R0)
; Top end address is: 12 (R3)
; Left end address is: 8 (R2)
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
; X start address is: 0 (R0)
; Y start address is: 4 (R1)
; Left start address is: 8 (R2)
; Top start address is: 12 (R3)
; Width start address is: 20 (R5)
LDRH	R5, [SP, #0]
; Height start address is: 24 (R6)
LDRH	R6, [SP, #4]
;PerfectEnvironment_driver.c,436 :: 		if ( ( Left<= X ) && ( Left+ Width - 1 >= X ) &&
CMP	R2, R0
IT	HI
BHI	L_PerfectEnvironment_driver_IsInsideObject124
ADDS	R4, R2, R5
UXTH	R4, R4
; Left end address is: 8 (R2)
; Width end address is: 20 (R5)
SUBS	R4, R4, #1
UXTH	R4, R4
CMP	R4, R0
IT	CC
BCC	L_PerfectEnvironment_driver_IsInsideObject123
; X end address is: 0 (R0)
;PerfectEnvironment_driver.c,437 :: 		( Top <= Y )  && ( Top + Height - 1 >= Y ) )
CMP	R3, R1
IT	HI
BHI	L_PerfectEnvironment_driver_IsInsideObject122
ADDS	R4, R3, R6
UXTH	R4, R4
; Top end address is: 12 (R3)
; Height end address is: 24 (R6)
SUBS	R4, R4, #1
UXTH	R4, R4
CMP	R4, R1
IT	CC
BCC	L_PerfectEnvironment_driver_IsInsideObject121
; Y end address is: 4 (R1)
L_PerfectEnvironment_driver_IsInsideObject120:
;PerfectEnvironment_driver.c,438 :: 		return 1;
MOVS	R0, #1
IT	AL
BAL	L_end_IsInsideObject
;PerfectEnvironment_driver.c,436 :: 		if ( ( Left<= X ) && ( Left+ Width - 1 >= X ) &&
L_PerfectEnvironment_driver_IsInsideObject124:
L_PerfectEnvironment_driver_IsInsideObject123:
;PerfectEnvironment_driver.c,437 :: 		( Top <= Y )  && ( Top + Height - 1 >= Y ) )
L_PerfectEnvironment_driver_IsInsideObject122:
L_PerfectEnvironment_driver_IsInsideObject121:
;PerfectEnvironment_driver.c,440 :: 		return 0;
MOVS	R0, #0
;PerfectEnvironment_driver.c,441 :: 		}
L_end_IsInsideObject:
BX	LR
; end of PerfectEnvironment_driver_IsInsideObject
_DrawButton:
;PerfectEnvironment_driver.c,448 :: 		void DrawButton( TButton *Abutton ) {
; Abutton start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; Abutton end address is: 0 (R0)
; Abutton start address is: 0 (R0)
;PerfectEnvironment_driver.c,450 :: 		if ( Abutton->Visible != 0 ) {
ADDW	R1, R0, #18
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_DrawButton4
;PerfectEnvironment_driver.c,451 :: 		if ( object_pressed == 1 ) {
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton5
;PerfectEnvironment_driver.c,452 :: 		object_pressed = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
STRB	R2, [R1, #0]
;PerfectEnvironment_driver.c,453 :: 		TFT_Set_Brush( Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color );
ADDW	R1, R0, #42
LDRH	R1, [R1, #0]
UXTH	R6, R1
ADDW	R1, R0, #44
LDRH	R1, [R1, #0]
UXTH	R5, R1
ADDW	R1, R0, #40
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDW	R1, R0, #39
LDRB	R1, [R1, #0]
UXTB	R3, R1
ADDW	R1, R0, #50
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDRB	R1, [R1, #0]
STR	R0, [SP, #4]
UXTB	R0, R1
UXTH	R1, R2
UXTB	R2, R3
UXTB	R3, R4
PUSH	(R6)
PUSH	(R5)
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
LDR	R0, [SP, #4]
;PerfectEnvironment_driver.c,454 :: 		}
IT	AL
BAL	L_DrawButton6
L_DrawButton5:
;PerfectEnvironment_driver.c,456 :: 		TFT_Set_Brush( Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color );
ADDW	R1, R0, #44
LDRH	R1, [R1, #0]
UXTH	R6, R1
ADDW	R1, R0, #42
LDRH	R1, [R1, #0]
UXTH	R5, R1
ADDW	R1, R0, #40
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDW	R1, R0, #39
LDRB	R1, [R1, #0]
UXTB	R3, R1
ADDW	R1, R0, #46
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDRB	R1, [R1, #0]
STR	R0, [SP, #4]
UXTB	R0, R1
UXTH	R1, R2
UXTB	R2, R3
UXTB	R3, R4
PUSH	(R6)
PUSH	(R5)
BL	_TFT_Set_Brush+0
ADD	SP, SP, #8
LDR	R0, [SP, #4]
;PerfectEnvironment_driver.c,457 :: 		}
L_DrawButton6:
;PerfectEnvironment_driver.c,458 :: 		TFT_Set_Pen( Abutton->Pen_Color, Abutton->Pen_Width );
ADDW	R1, R0, #14
LDRB	R1, [R1, #0]
UXTB	R2, R1
ADDW	R1, R0, #16
LDRH	R1, [R1, #0]
STR	R0, [SP, #4]
UXTH	R0, R1
UXTB	R1, R2
BL	_TFT_Set_Pen+0
LDR	R0, [SP, #4]
;PerfectEnvironment_driver.c,459 :: 		TFT_Rectangle( Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1 );
ADDW	R1, R0, #8
LDRH	R2, [R1, #0]
ADDW	R1, R0, #12
LDRH	R1, [R1, #0]
ADDS	R1, R2, R1
UXTH	R1, R1
SUBS	R5, R1, #1
ADDS	R1, R0, #6
LDRH	R4, [R1, #0]
ADDW	R1, R0, #10
LDRH	R1, [R1, #0]
ADDS	R1, R4, R1
UXTH	R1, R1
SUBS	R3, R1, #1
SXTH	R2, R2
SXTH	R1, R4
STR	R0, [SP, #4]
SXTH	R0, R1
SXTH	R1, R2
SXTH	R2, R3
SXTH	R3, R5
BL	_TFT_Rectangle+0
LDR	R0, [SP, #4]
;PerfectEnvironment_driver.c,460 :: 		if ( Abutton->VerticalText != 0 )
ADDW	R1, R0, #38
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_DrawButton7
;PerfectEnvironment_driver.c,461 :: 		TFT_Set_Font( Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN );
ADDW	R1, R0, #36
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #32
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
MOVS	R2, #2
BL	_TFT_Set_Font+0
LDR	R0, [SP, #4]
IT	AL
BAL	L_DrawButton8
L_DrawButton7:
;PerfectEnvironment_driver.c,463 :: 		TFT_Set_Font( Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL );
ADDW	R1, R0, #36
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #32
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
MOVS	R2, #0
BL	_TFT_Set_Font+0
LDR	R0, [SP, #4]
L_DrawButton8:
;PerfectEnvironment_driver.c,464 :: 		TFT_Write_Text_Return_Pos( Abutton->Caption, Abutton->Left, Abutton->Top);
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
UXTH	R3, R1
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #24
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R3
BL	_TFT_Write_Text_Return_Pos+0
LDR	R0, [SP, #4]
;PerfectEnvironment_driver.c,465 :: 		if ( Abutton->TextAlign == _taLeft )
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_DrawButton9
;PerfectEnvironment_driver.c,466 :: 		ALeft = Abutton->Left + 4;
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
ADDS	R1, R1, #4
STRH	R1, [SP, #8]
IT	AL
BAL	L_DrawButton10
L_DrawButton9:
;PerfectEnvironment_driver.c,467 :: 		else if ( Abutton->TextAlign == _taCenter )
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton11
;PerfectEnvironment_driver.c,468 :: 		ALeft = Abutton->Left + ( Abutton->Width - caption_length ) / 2;
ADDS	R1, R0, #6
LDRH	R3, [R1, #0]
ADDW	R1, R0, #10
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_length+0)
MOVT	R1, #hi_addr(_caption_length+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R1, R3, R1
STRH	R1, [SP, #8]
IT	AL
BAL	L_DrawButton12
L_DrawButton11:
;PerfectEnvironment_driver.c,469 :: 		else if ( Abutton->TextAlign == _taRight )
ADDW	R1, R0, #28
LDRB	R1, [R1, #0]
CMP	R1, #2
IT	NE
BNE	L_DrawButton13
;PerfectEnvironment_driver.c,470 :: 		ALeft = Abutton->Left + Abutton->Width - caption_length - 4;
ADDS	R1, R0, #6
LDRH	R2, [R1, #0]
ADDW	R1, R0, #10
LDRH	R1, [R1, #0]
ADDS	R2, R2, R1
UXTH	R2, R2
MOVW	R1, #lo_addr(_caption_length+0)
MOVT	R1, #hi_addr(_caption_length+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
SUBS	R1, R1, #4
STRH	R1, [SP, #8]
L_DrawButton13:
L_DrawButton12:
L_DrawButton10:
;PerfectEnvironment_driver.c,472 :: 		if ( Abutton->TextAlignVertical == _tavTop)
ADDW	R1, R0, #29
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_DrawButton14
;PerfectEnvironment_driver.c,473 :: 		ATop = Abutton->Top + 4;
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
ADDS	R1, R1, #4
STRH	R1, [SP, #10]
IT	AL
BAL	L_DrawButton15
L_DrawButton14:
;PerfectEnvironment_driver.c,474 :: 		else if ( Abutton->TextAlignVertical == _tavMiddle )
ADDW	R1, R0, #29
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawButton16
;PerfectEnvironment_driver.c,475 :: 		ATop = Abutton->Top + ( ( Abutton->Height - caption_height ) / 2);
ADDW	R1, R0, #8
LDRH	R3, [R1, #0]
ADDW	R1, R0, #12
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_height+0)
MOVT	R1, #hi_addr(_caption_height+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
LSRS	R1, R1, #1
UXTH	R1, R1
ADDS	R1, R3, R1
STRH	R1, [SP, #10]
IT	AL
BAL	L_DrawButton17
L_DrawButton16:
;PerfectEnvironment_driver.c,476 :: 		else if ( Abutton->TextAlignVertical == _tavBottom)
ADDW	R1, R0, #29
LDRB	R1, [R1, #0]
CMP	R1, #2
IT	NE
BNE	L_DrawButton18
;PerfectEnvironment_driver.c,477 :: 		ATop = Abutton->Top + ( Abutton->Height - caption_height - 4);
ADDW	R1, R0, #8
LDRH	R3, [R1, #0]
ADDW	R1, R0, #12
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_caption_height+0)
MOVT	R1, #hi_addr(_caption_height+0)
LDRH	R1, [R1, #0]
SUB	R1, R2, R1
UXTH	R1, R1
SUBS	R1, R1, #4
UXTH	R1, R1
ADDS	R1, R3, R1
STRH	R1, [SP, #10]
L_DrawButton18:
L_DrawButton17:
L_DrawButton15:
;PerfectEnvironment_driver.c,479 :: 		TFT_Write_Text( Abutton->Caption, ALeft, ATop);
ADDW	R1, R0, #24
; Abutton end address is: 0 (R0)
LDR	R1, [R1, #0]
LDRH	R2, [SP, #10]
MOV	R0, R1
LDRH	R1, [SP, #8]
BL	_TFT_Write_Text+0
;PerfectEnvironment_driver.c,480 :: 		}
L_DrawButton4:
;PerfectEnvironment_driver.c,481 :: 		}
L_end_DrawButton:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _DrawButton
_DrawLabel:
;PerfectEnvironment_driver.c,483 :: 		void DrawLabel( TLabel *ALabel ) {
; ALabel start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; ALabel end address is: 0 (R0)
; ALabel start address is: 0 (R0)
;PerfectEnvironment_driver.c,484 :: 		if ( ALabel->Visible != 0 ) {
ADDW	R1, R0, #27
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_DrawLabel19
;PerfectEnvironment_driver.c,485 :: 		if ( ALabel->VerticalText != 0 )
ADDW	R1, R0, #26
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_DrawLabel20
;PerfectEnvironment_driver.c,486 :: 		TFT_Set_Font( ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN );
ADDW	R1, R0, #24
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
MOVS	R2, #2
BL	_TFT_Set_Font+0
LDR	R0, [SP, #4]
IT	AL
BAL	L_DrawLabel21
L_DrawLabel20:
;PerfectEnvironment_driver.c,488 :: 		TFT_Set_Font( ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL );
ADDW	R1, R0, #24
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #20
LDR	R1, [R1, #0]
STR	R0, [SP, #4]
MOV	R0, R1
UXTH	R1, R2
MOVS	R2, #0
BL	_TFT_Set_Font+0
LDR	R0, [SP, #4]
L_DrawLabel21:
;PerfectEnvironment_driver.c,489 :: 		TFT_Write_Text( ALabel->Caption, ALabel->Left, ALabel->Top);
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
UXTH	R3, R1
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDW	R1, R0, #16
; ALabel end address is: 0 (R0)
LDR	R1, [R1, #0]
MOV	R0, R1
UXTH	R1, R2
UXTH	R2, R3
BL	_TFT_Write_Text+0
;PerfectEnvironment_driver.c,490 :: 		}
L_DrawLabel19:
;PerfectEnvironment_driver.c,491 :: 		}
L_end_DrawLabel:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DrawLabel
_DrawImage:
;PerfectEnvironment_driver.c,493 :: 		void DrawImage( TImage *AImage ) {
; AImage start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; AImage end address is: 0 (R0)
; AImage start address is: 0 (R0)
;PerfectEnvironment_driver.c,494 :: 		if ( AImage->Visible != 0 ) {
ADDW	R1, R0, #20
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	EQ
BEQ	L_DrawImage22
;PerfectEnvironment_driver.c,495 :: 		if ( AImage->Picture_Type == 0 )
ADDW	R1, R0, #22
LDRB	R1, [R1, #0]
CMP	R1, #0
IT	NE
BNE	L_DrawImage23
;PerfectEnvironment_driver.c,496 :: 		TFT_Image( AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio );
ADDW	R1, R0, #23
LDRB	R1, [R1, #0]
UXTB	R4, R1
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R3, R1
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDS	R1, R0, #6
LDRH	R1, [R1, #0]
STR	R0, [SP, #4]
UXTH	R0, R1
UXTH	R1, R2
MOV	R2, R3
UXTB	R3, R4
BL	_TFT_Image+0
LDR	R0, [SP, #4]
L_DrawImage23:
;PerfectEnvironment_driver.c,497 :: 		if ( AImage->Picture_Type == 1 )
ADDW	R1, R0, #22
LDRB	R1, [R1, #0]
CMP	R1, #1
IT	NE
BNE	L_DrawImage24
;PerfectEnvironment_driver.c,498 :: 		TFT_Image_Jpeg( AImage->Left, AImage->Top, AImage->Picture_Name );
ADDW	R1, R0, #16
LDR	R1, [R1, #0]
MOV	R3, R1
ADDW	R1, R0, #8
LDRH	R1, [R1, #0]
UXTH	R2, R1
ADDS	R1, R0, #6
; AImage end address is: 0 (R0)
LDRH	R1, [R1, #0]
UXTH	R0, R1
UXTH	R1, R2
MOV	R2, R3
BL	_TFT_Image_Jpeg+0
L_DrawImage24:
;PerfectEnvironment_driver.c,499 :: 		}
L_DrawImage22:
;PerfectEnvironment_driver.c,500 :: 		}
L_end_DrawImage:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DrawImage
_DrawScreen:
;PerfectEnvironment_driver.c,502 :: 		void DrawScreen( TScreen *aScreen ) {
; aScreen start address is: 0 (R0)
SUB	SP, SP, #36
STR	LR, [SP, #0]
; aScreen end address is: 0 (R0)
; aScreen start address is: 0 (R0)
;PerfectEnvironment_driver.c,513 :: 		object_pressed = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_object_pressed+0)
MOVT	R1, #hi_addr(_object_pressed+0)
STRB	R2, [R1, #0]
;PerfectEnvironment_driver.c,514 :: 		order = 0;
MOVS	R1, #0
STRH	R1, [SP, #8]
;PerfectEnvironment_driver.c,515 :: 		button_idx = 0;
MOVS	R1, #0
STRB	R1, [SP, #10]
;PerfectEnvironment_driver.c,516 :: 		label_idx = 0;
MOVS	R1, #0
STRB	R1, [SP, #16]
;PerfectEnvironment_driver.c,517 :: 		image_idx = 0;
MOVS	R1, #0
STRB	R1, [SP, #24]
;PerfectEnvironment_driver.c,518 :: 		CurrentScreen = aScreen;
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
STR	R0, [R1, #0]
; aScreen end address is: 0 (R0)
;PerfectEnvironment_driver.c,519 :: 		TFT_Set_DBC_SSD1963( 0 );
MOVS	R0, #0
BL	_TFT_Set_DBC_SSD1963+0
;PerfectEnvironment_driver.c,521 :: 		if ( ( display_width != CurrentScreen->Width ) || ( display_height != CurrentScreen->Height ) ) {
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_width+0)
MOVT	R1, #hi_addr(_display_width+0)
LDRH	R1, [R1, #0]
CMP	R1, R2
IT	NE
BNE	L__DrawScreen127
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #4
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_height+0)
MOVT	R1, #hi_addr(_display_height+0)
LDRH	R1, [R1, #0]
CMP	R1, R2
IT	NE
BNE	L__DrawScreen126
IT	AL
BAL	L_DrawScreen27
L__DrawScreen127:
L__DrawScreen126:
;PerfectEnvironment_driver.c,522 :: 		save_bled = TFT_BLED;
MOVW	R2, #lo_addr(GPIOF_ODR+0)
MOVT	R2, #hi_addr(GPIOF_ODR+0)
_LX	[R2, ByteOffset(GPIOF_ODR+0)]
STRB	R1, [SP, #32]
;PerfectEnvironment_driver.c,523 :: 		TFT_BLED           = 0;
MOVS	R1, #0
SXTB	R1, R1
_SX	[R2, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,524 :: 		TFT_Set_Active( Set_Index, Write_Command, Write_Data );
MOVW	R3, #lo_addr(_Write_Data+0)
MOVT	R3, #hi_addr(_Write_Data+0)
MOVW	R2, #lo_addr(_Write_Command+0)
MOVT	R2, #hi_addr(_Write_Command+0)
MOVW	R1, #lo_addr(_Set_Index+0)
MOVT	R1, #hi_addr(_Set_Index+0)
MOV	R0, R1
MOV	R1, R2
MOV	R2, R3
BL	_TFT_Set_Active+0
;PerfectEnvironment_driver.c,525 :: 		TFT_Init_SSD1963_Board_43( CurrentScreen->Width, CurrentScreen->Height );
MOVW	R3, #lo_addr(_CurrentScreen+0)
MOVT	R3, #hi_addr(_CurrentScreen+0)
LDR	R1, [R3, #0]
ADDS	R1, R1, #4
LDRH	R1, [R1, #0]
UXTH	R2, R1
MOV	R1, R3
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R1, [R1, #0]
UXTH	R0, R1
UXTH	R1, R2
BL	_TFT_Init_SSD1963_Board_43+0
;PerfectEnvironment_driver.c,526 :: 		FT5XX6_SetSize( CurrentScreen->Width, CurrentScreen->Height );
MOVW	R3, #lo_addr(_CurrentScreen+0)
MOVT	R3, #hi_addr(_CurrentScreen+0)
LDR	R1, [R3, #0]
ADDS	R1, R1, #4
LDRH	R1, [R1, #0]
UXTH	R2, R1
MOV	R1, R3
LDR	R1, [R1, #0]
ADDS	R1, R1, #2
LDRH	R1, [R1, #0]
UXTH	R0, R1
UXTH	R1, R2
BL	_FT5XX6_SetSize+0
;PerfectEnvironment_driver.c,527 :: 		TFT_Fill_Screen( CurrentScreen->Color );
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
LDRH	R1, [R1, #0]
UXTH	R0, R1
BL	_TFT_Fill_Screen+0
;PerfectEnvironment_driver.c,529 :: 		display_width = CurrentScreen->Width;
MOVW	R3, #lo_addr(_CurrentScreen+0)
MOVT	R3, #hi_addr(_CurrentScreen+0)
LDR	R1, [R3, #0]
ADDS	R1, R1, #2
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_width+0)
MOVT	R1, #hi_addr(_display_width+0)
STRH	R2, [R1, #0]
;PerfectEnvironment_driver.c,530 :: 		display_height = CurrentScreen->Height;
MOV	R1, R3
LDR	R1, [R1, #0]
ADDS	R1, R1, #4
LDRH	R2, [R1, #0]
MOVW	R1, #lo_addr(_display_height+0)
MOVT	R1, #hi_addr(_display_height+0)
STRH	R2, [R1, #0]
;PerfectEnvironment_driver.c,531 :: 		TFT_BLED       = save_bled;
LDRB	R2, [SP, #32]
MOVW	R1, #lo_addr(GPIOF_ODR+0)
MOVT	R1, #hi_addr(GPIOF_ODR+0)
_SX	[R1, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,532 :: 		}
IT	AL
BAL	L_DrawScreen28
L_DrawScreen27:
;PerfectEnvironment_driver.c,534 :: 		TFT_Fill_Screen( CurrentScreen->Color );
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
LDRH	R1, [R1, #0]
UXTH	R0, R1
BL	_TFT_Fill_Screen+0
L_DrawScreen28:
;PerfectEnvironment_driver.c,537 :: 		while ( order < CurrentScreen->ObjectsCount ) {
L_DrawScreen29:
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, R1, #6
LDRH	R2, [R1, #0]
LDRH	R1, [SP, #8]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen30
;PerfectEnvironment_driver.c,538 :: 		if ( button_idx < CurrentScreen->ButtonsCount ) {
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #8
LDRH	R2, [R1, #0]
LDRB	R1, [SP, #10]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen31
;PerfectEnvironment_driver.c,539 :: 		local_button = GetButton( button_idx );
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #12
LDR	R2, [R1, #0]
LDRB	R1, [SP, #10]
LSLS	R1, R1, #2
ADDS	R1, R2, R1
LDR	R1, [R1, #0]
STR	R1, [SP, #12]
;PerfectEnvironment_driver.c,540 :: 		if ( order == local_button->Order ) {
ADDS	R1, R1, #4
LDRB	R2, [R1, #0]
LDRH	R1, [SP, #8]
CMP	R1, R2
IT	NE
BNE	L_DrawScreen32
;PerfectEnvironment_driver.c,541 :: 		button_idx++;
LDRB	R1, [SP, #10]
ADDS	R1, R1, #1
STRB	R1, [SP, #10]
;PerfectEnvironment_driver.c,542 :: 		order++;
LDRH	R1, [SP, #8]
ADDS	R1, R1, #1
STRH	R1, [SP, #8]
;PerfectEnvironment_driver.c,543 :: 		DrawButton( local_button );
LDR	R0, [SP, #12]
BL	_DrawButton+0
;PerfectEnvironment_driver.c,544 :: 		}
L_DrawScreen32:
;PerfectEnvironment_driver.c,545 :: 		}
L_DrawScreen31:
;PerfectEnvironment_driver.c,547 :: 		if ( label_idx < CurrentScreen->LabelsCount ) {
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #16
LDRH	R2, [R1, #0]
LDRB	R1, [SP, #16]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen33
;PerfectEnvironment_driver.c,548 :: 		local_label = GetLabel( label_idx );
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #20
LDR	R2, [R1, #0]
LDRB	R1, [SP, #16]
LSLS	R1, R1, #2
ADDS	R1, R2, R1
LDR	R1, [R1, #0]
STR	R1, [SP, #20]
;PerfectEnvironment_driver.c,549 :: 		if ( order == local_label->Order ) {
ADDS	R1, R1, #4
LDRB	R2, [R1, #0]
LDRH	R1, [SP, #8]
CMP	R1, R2
IT	NE
BNE	L_DrawScreen34
;PerfectEnvironment_driver.c,550 :: 		label_idx++;
LDRB	R1, [SP, #16]
ADDS	R1, R1, #1
STRB	R1, [SP, #16]
;PerfectEnvironment_driver.c,551 :: 		order++;
LDRH	R1, [SP, #8]
ADDS	R1, R1, #1
STRH	R1, [SP, #8]
;PerfectEnvironment_driver.c,552 :: 		DrawLabel( local_label );
LDR	R0, [SP, #20]
BL	_DrawLabel+0
;PerfectEnvironment_driver.c,553 :: 		}
L_DrawScreen34:
;PerfectEnvironment_driver.c,554 :: 		}
L_DrawScreen33:
;PerfectEnvironment_driver.c,556 :: 		if ( image_idx < CurrentScreen->ImagesCount ) {
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #24
LDRH	R2, [R1, #0]
LDRB	R1, [SP, #24]
CMP	R1, R2
IT	CS
BCS	L_DrawScreen35
;PerfectEnvironment_driver.c,557 :: 		local_image = GetImage( image_idx );
MOVW	R1, #lo_addr(_CurrentScreen+0)
MOVT	R1, #hi_addr(_CurrentScreen+0)
LDR	R1, [R1, #0]
ADDS	R1, #28
LDR	R2, [R1, #0]
LDRB	R1, [SP, #24]
LSLS	R1, R1, #2
ADDS	R1, R2, R1
LDR	R1, [R1, #0]
STR	R1, [SP, #28]
;PerfectEnvironment_driver.c,558 :: 		if ( order == local_image->Order ) {
ADDS	R1, R1, #4
LDRB	R2, [R1, #0]
LDRH	R1, [SP, #8]
CMP	R1, R2
IT	NE
BNE	L_DrawScreen36
;PerfectEnvironment_driver.c,559 :: 		image_idx++;
LDRB	R1, [SP, #24]
ADDS	R1, R1, #1
STRB	R1, [SP, #24]
;PerfectEnvironment_driver.c,560 :: 		order++;
LDRH	R1, [SP, #8]
ADDS	R1, R1, #1
STRH	R1, [SP, #8]
;PerfectEnvironment_driver.c,561 :: 		DrawImage( local_image );
LDR	R0, [SP, #28]
BL	_DrawImage+0
;PerfectEnvironment_driver.c,562 :: 		}
L_DrawScreen36:
;PerfectEnvironment_driver.c,563 :: 		}
L_DrawScreen35:
;PerfectEnvironment_driver.c,564 :: 		}
IT	AL
BAL	L_DrawScreen29
L_DrawScreen30:
;PerfectEnvironment_driver.c,565 :: 		for ( i = 0; i < 256; i++ )
; i start address is: 0 (R0)
MOVS	R0, #0
; i end address is: 0 (R0)
L_DrawScreen37:
; i start address is: 0 (R0)
CMP	R0, #256
IT	CS
BCS	L_DrawScreen38
;PerfectEnvironment_driver.c,567 :: 		TFT_Set_DBC_SSD1963( i );
STRH	R0, [SP, #4]
UXTB	R0, R0
BL	_TFT_Set_DBC_SSD1963+0
LDRH	R0, [SP, #4]
;PerfectEnvironment_driver.c,568 :: 		Delay_ms(  15 );
MOVW	R7, #53566
MOVT	R7, #12
NOP
NOP
L_DrawScreen40:
SUBS	R7, R7, #1
BNE	L_DrawScreen40
NOP
NOP
NOP
;PerfectEnvironment_driver.c,565 :: 		for ( i = 0; i < 256; i++ )
ADDS	R1, R0, #1
; i end address is: 0 (R0)
; i start address is: 4 (R1)
;PerfectEnvironment_driver.c,569 :: 		}
UXTH	R0, R1
; i end address is: 4 (R1)
IT	AL
BAL	L_DrawScreen37
L_DrawScreen38:
;PerfectEnvironment_driver.c,570 :: 		}
L_end_DrawScreen:
LDR	LR, [SP, #0]
ADD	SP, SP, #36
BX	LR
; end of _DrawScreen
_Get_Object:
;PerfectEnvironment_driver.c,572 :: 		void Get_Object( unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
; X start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
; X start address is: 0 (R0)
; Y start address is: 4 (R1)
;PerfectEnvironment_driver.c,573 :: 		button_order        = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,574 :: 		label_order         = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,575 :: 		image_order         = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,577 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
; X end address is: 0 (R0)
; Y end address is: 4 (R1)
UXTH	R8, R0
UXTH	R7, R1
L_Get_Object42:
; Y start address is: 28 (R7)
; X start address is: 32 (R8)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	CS
BCS	L_Get_Object43
;PerfectEnvironment_driver.c,578 :: 		local_button = GetButton( _object_count );
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #12
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
LSLS	R2, R2, #2
ADDS	R2, R3, R2
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_local_button+0)
MOVT	R2, #hi_addr(_local_button+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,579 :: 		if ( local_button->Active != 0 ) {
ADDW	R2, R3, #19
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Get_Object45
;PerfectEnvironment_driver.c,581 :: 		local_button->Width, local_button->Height ) == 1 ) {
MOVW	R6, #lo_addr(_local_button+0)
MOVT	R6, #hi_addr(_local_button+0)
LDR	R2, [R6, #0]
ADDS	R2, #12
LDRH	R2, [R2, #0]
UXTH	R5, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #10
LDRH	R2, [R2, #0]
UXTH	R4, R2
;PerfectEnvironment_driver.c,580 :: 		if ( IsInsideObject( X, Y, local_button->Left, local_button->Top,
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R2, [R2, #0]
UXTH	R3, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, R2, #6
LDRH	R2, [R2, #0]
UXTH	R1, R7
UXTH	R0, R8
;PerfectEnvironment_driver.c,581 :: 		local_button->Width, local_button->Height ) == 1 ) {
PUSH	(R5)
PUSH	(R4)
BL	PerfectEnvironment_driver_IsInsideObject+0
ADD	SP, SP, #8
CMP	R0, #1
IT	NE
BNE	L_Get_Object46
;PerfectEnvironment_driver.c,582 :: 		button_order = local_button->Order;
MOVW	R4, #lo_addr(_local_button+0)
MOVT	R4, #hi_addr(_local_button+0)
LDR	R2, [R4, #0]
ADDS	R2, R2, #4
LDRB	R3, [R2, #0]
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,583 :: 		exec_button = local_button;
MOV	R2, R4
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,584 :: 		}
L_Get_Object46:
;PerfectEnvironment_driver.c,585 :: 		}
L_Get_Object45:
;PerfectEnvironment_driver.c,577 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
MOVW	R3, #lo_addr(__object_count+0)
MOVT	R3, #hi_addr(__object_count+0)
LDRSH	R2, [R3, #0]
ADDS	R2, R2, #1
STRH	R2, [R3, #0]
;PerfectEnvironment_driver.c,586 :: 		}
IT	AL
BAL	L_Get_Object42
L_Get_Object43:
;PerfectEnvironment_driver.c,589 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
; Y end address is: 28 (R7)
; X end address is: 32 (R8)
STRH	R8, [SP, #4]
UXTH	R8, R7
LDRH	R7, [SP, #4]
L_Get_Object47:
; X start address is: 28 (R7)
; Y start address is: 32 (R8)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #16
LDRH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	CS
BCS	L_Get_Object48
;PerfectEnvironment_driver.c,590 :: 		local_label = GetLabel( _object_count );
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #20
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
LSLS	R2, R2, #2
ADDS	R2, R3, R2
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_local_label+0)
MOVT	R2, #hi_addr(_local_label+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,591 :: 		if ( local_label->Active != 0 ) {
ADDW	R2, R3, #28
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Get_Object50
;PerfectEnvironment_driver.c,593 :: 		local_label->Width, local_label->Height ) == 1 ) {
MOVW	R6, #lo_addr(_local_label+0)
MOVT	R6, #hi_addr(_local_label+0)
LDR	R2, [R6, #0]
ADDS	R2, #12
LDRH	R2, [R2, #0]
UXTH	R5, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #10
LDRH	R2, [R2, #0]
UXTH	R4, R2
;PerfectEnvironment_driver.c,592 :: 		if ( IsInsideObject( X, Y, local_label->Left, local_label->Top,
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R2, [R2, #0]
UXTH	R3, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, R2, #6
LDRH	R2, [R2, #0]
UXTH	R1, R8
UXTH	R0, R7
;PerfectEnvironment_driver.c,593 :: 		local_label->Width, local_label->Height ) == 1 ) {
PUSH	(R5)
PUSH	(R4)
BL	PerfectEnvironment_driver_IsInsideObject+0
ADD	SP, SP, #8
CMP	R0, #1
IT	NE
BNE	L_Get_Object51
;PerfectEnvironment_driver.c,594 :: 		label_order = local_label->Order;
MOVW	R4, #lo_addr(_local_label+0)
MOVT	R4, #hi_addr(_local_label+0)
LDR	R2, [R4, #0]
ADDS	R2, R2, #4
LDRB	R3, [R2, #0]
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,595 :: 		exec_label = local_label;
MOV	R2, R4
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,596 :: 		}
L_Get_Object51:
;PerfectEnvironment_driver.c,597 :: 		}
L_Get_Object50:
;PerfectEnvironment_driver.c,589 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
MOVW	R3, #lo_addr(__object_count+0)
MOVT	R3, #hi_addr(__object_count+0)
LDRSH	R2, [R3, #0]
ADDS	R2, R2, #1
STRH	R2, [R3, #0]
;PerfectEnvironment_driver.c,598 :: 		}
IT	AL
BAL	L_Get_Object47
L_Get_Object48:
;PerfectEnvironment_driver.c,601 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
; X end address is: 28 (R7)
; Y end address is: 32 (R8)
STRH	R8, [SP, #4]
UXTH	R8, R7
LDRH	R7, [SP, #4]
L_Get_Object52:
; X start address is: 32 (R8)
; Y start address is: 28 (R7)
; Y start address is: 28 (R7)
; Y end address is: 28 (R7)
; X start address is: 32 (R8)
; X end address is: 32 (R8)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #24
LDRH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	CS
BCS	L_Get_Object53
; Y end address is: 28 (R7)
; X end address is: 32 (R8)
;PerfectEnvironment_driver.c,602 :: 		local_image = GetImage( _object_count );
; X start address is: 32 (R8)
; Y start address is: 28 (R7)
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
ADDS	R2, #28
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
LSLS	R2, R2, #2
ADDS	R2, R3, R2
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_local_image+0)
MOVT	R2, #hi_addr(_local_image+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,603 :: 		if ( local_image->Active != 0 ) {
ADDW	R2, R3, #21
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Get_Object55
;PerfectEnvironment_driver.c,605 :: 		local_image->Width, local_image->Height ) == 1 ) {
MOVW	R6, #lo_addr(_local_image+0)
MOVT	R6, #hi_addr(_local_image+0)
LDR	R2, [R6, #0]
ADDS	R2, #12
LDRH	R2, [R2, #0]
UXTH	R5, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #10
LDRH	R2, [R2, #0]
UXTH	R4, R2
;PerfectEnvironment_driver.c,604 :: 		if ( IsInsideObject( X, Y, local_image->Left, local_image->Top,
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, #8
LDRH	R2, [R2, #0]
UXTH	R3, R2
MOV	R2, R6
LDR	R2, [R2, #0]
ADDS	R2, R2, #6
LDRH	R2, [R2, #0]
UXTH	R1, R7
UXTH	R0, R8
;PerfectEnvironment_driver.c,605 :: 		local_image->Width, local_image->Height ) == 1 ) {
PUSH	(R5)
PUSH	(R4)
BL	PerfectEnvironment_driver_IsInsideObject+0
ADD	SP, SP, #8
CMP	R0, #1
IT	NE
BNE	L_Get_Object56
;PerfectEnvironment_driver.c,606 :: 		image_order = local_image->Order;
MOVW	R4, #lo_addr(_local_image+0)
MOVT	R4, #hi_addr(_local_image+0)
LDR	R2, [R4, #0]
ADDS	R2, R2, #4
LDRB	R3, [R2, #0]
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,607 :: 		exec_image = local_image;
MOV	R2, R4
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,608 :: 		}
L_Get_Object56:
;PerfectEnvironment_driver.c,609 :: 		}
L_Get_Object55:
;PerfectEnvironment_driver.c,601 :: 		for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
MOVW	R3, #lo_addr(__object_count+0)
MOVT	R3, #hi_addr(__object_count+0)
LDRSH	R2, [R3, #0]
ADDS	R2, R2, #1
STRH	R2, [R3, #0]
;PerfectEnvironment_driver.c,610 :: 		}
; Y end address is: 28 (R7)
; X end address is: 32 (R8)
IT	AL
BAL	L_Get_Object52
L_Get_Object53:
;PerfectEnvironment_driver.c,612 :: 		_object_count = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,613 :: 		if ( button_order >  _object_count )
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	LE
BLE	L_Get_Object57
;PerfectEnvironment_driver.c,614 :: 		_object_count = button_order;
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
L_Get_Object57:
;PerfectEnvironment_driver.c,615 :: 		if ( label_order >  _object_count )
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	LE
BLE	L_Get_Object58
;PerfectEnvironment_driver.c,616 :: 		_object_count = label_order;
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
L_Get_Object58:
;PerfectEnvironment_driver.c,617 :: 		if ( image_order >  _object_count )
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	LE
BLE	L_Get_Object59
;PerfectEnvironment_driver.c,618 :: 		_object_count = image_order;
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
STRH	R3, [R2, #0]
L_Get_Object59:
;PerfectEnvironment_driver.c,619 :: 		}
L_end_Get_Object:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _Get_Object
_Process_TP_Press:
;PerfectEnvironment_driver.c,622 :: 		void Process_TP_Press( unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
; X start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
; X start address is: 0 (R0)
; Y start address is: 4 (R1)
;PerfectEnvironment_driver.c,623 :: 		exec_button         = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,624 :: 		exec_label          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,625 :: 		exec_image          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,627 :: 		Get_Object( X, Y);
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
BL	_Get_Object+0
;PerfectEnvironment_driver.c,629 :: 		if ( _object_count != -1 ) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_Process_TP_Press60
;PerfectEnvironment_driver.c,630 :: 		if ( _object_count == button_order ) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Press61
;PerfectEnvironment_driver.c,631 :: 		if ( exec_button->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Press62
;PerfectEnvironment_driver.c,632 :: 		if ( exec_button->OnPressPtr != 0 ) {
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #64
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Press63
;PerfectEnvironment_driver.c,633 :: 		exec_button->OnPressPtr( );
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #64
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,634 :: 		return;
IT	AL
BAL	L_end_Process_TP_Press
;PerfectEnvironment_driver.c,635 :: 		}
L_Process_TP_Press63:
;PerfectEnvironment_driver.c,636 :: 		}
L_Process_TP_Press62:
;PerfectEnvironment_driver.c,637 :: 		}
L_Process_TP_Press61:
;PerfectEnvironment_driver.c,639 :: 		if ( _object_count == label_order ) {
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Press64
;PerfectEnvironment_driver.c,640 :: 		if ( exec_label->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
LDR	R2, [R2, #0]
ADDS	R2, #28
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Press65
;PerfectEnvironment_driver.c,641 :: 		if ( exec_label->OnPressPtr != 0 ) {
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #44
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Press66
;PerfectEnvironment_driver.c,642 :: 		exec_label->OnPressPtr( );
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #44
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,643 :: 		return;
IT	AL
BAL	L_end_Process_TP_Press
;PerfectEnvironment_driver.c,644 :: 		}
L_Process_TP_Press66:
;PerfectEnvironment_driver.c,645 :: 		}
L_Process_TP_Press65:
;PerfectEnvironment_driver.c,646 :: 		}
L_Process_TP_Press64:
;PerfectEnvironment_driver.c,648 :: 		if ( _object_count == image_order ) {
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Press67
;PerfectEnvironment_driver.c,649 :: 		if ( exec_image->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
LDR	R2, [R2, #0]
ADDS	R2, #21
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Press68
;PerfectEnvironment_driver.c,650 :: 		if ( exec_image->OnPressPtr != 0 ) {
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #36
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Press69
;PerfectEnvironment_driver.c,651 :: 		exec_image->OnPressPtr( );
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #36
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,652 :: 		return;
IT	AL
BAL	L_end_Process_TP_Press
;PerfectEnvironment_driver.c,653 :: 		}
L_Process_TP_Press69:
;PerfectEnvironment_driver.c,654 :: 		}
L_Process_TP_Press68:
;PerfectEnvironment_driver.c,655 :: 		}
L_Process_TP_Press67:
;PerfectEnvironment_driver.c,657 :: 		}
L_Process_TP_Press60:
;PerfectEnvironment_driver.c,658 :: 		}
L_end_Process_TP_Press:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Process_TP_Press
_Process_TP_Up:
;PerfectEnvironment_driver.c,660 :: 		void Process_TP_Up( unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
; X start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
; X start address is: 0 (R0)
; Y start address is: 4 (R1)
;PerfectEnvironment_driver.c,662 :: 		switch ( PressedObjectType ) {
IT	AL
BAL	L_Process_TP_Up70
;PerfectEnvironment_driver.c,664 :: 		case 0: {
L_Process_TP_Up72:
;PerfectEnvironment_driver.c,665 :: 		if ( PressedObject != 0 ) {
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Up73
;PerfectEnvironment_driver.c,666 :: 		exec_button = ( TButton* )PressedObject;
MOVW	R4, #lo_addr(_PressedObject+0)
MOVT	R4, #hi_addr(_PressedObject+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,667 :: 		if ( ( exec_button->PressColEnabled != 0 ) && ( exec_button->OwnerScreen == CurrentScreen ) ) {
MOV	R2, R4
LDR	R2, [R2, #0]
ADDS	R2, #48
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L__Process_TP_Up130
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_CurrentScreen+0)
MOVT	R2, #hi_addr(_CurrentScreen+0)
LDR	R2, [R2, #0]
CMP	R3, R2
IT	NE
BNE	L__Process_TP_Up129
L__Process_TP_Up128:
;PerfectEnvironment_driver.c,668 :: 		DrawButton( exec_button );
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
STRH	R1, [SP, #4]
STRH	R0, [SP, #8]
MOV	R0, R2
BL	_DrawButton+0
LDRH	R0, [SP, #8]
LDRH	R1, [SP, #4]
;PerfectEnvironment_driver.c,667 :: 		if ( ( exec_button->PressColEnabled != 0 ) && ( exec_button->OwnerScreen == CurrentScreen ) ) {
L__Process_TP_Up130:
L__Process_TP_Up129:
;PerfectEnvironment_driver.c,670 :: 		break;
IT	AL
BAL	L_Process_TP_Up71
;PerfectEnvironment_driver.c,671 :: 		}
L_Process_TP_Up73:
;PerfectEnvironment_driver.c,672 :: 		break;
IT	AL
BAL	L_Process_TP_Up71
;PerfectEnvironment_driver.c,674 :: 		}
L_Process_TP_Up70:
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
LDRSH	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Up72
L_Process_TP_Up71:
;PerfectEnvironment_driver.c,676 :: 		exec_label          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,677 :: 		exec_image          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,679 :: 		Get_Object( X, Y);
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
BL	_Get_Object+0
;PerfectEnvironment_driver.c,682 :: 		if ( _object_count != -1 ) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_Process_TP_Up77
;PerfectEnvironment_driver.c,684 :: 		if ( _object_count == button_order ) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up78
;PerfectEnvironment_driver.c,685 :: 		if ( exec_button->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Up79
;PerfectEnvironment_driver.c,686 :: 		if ( exec_button->OnUpPtr != 0 )
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #52
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up80
;PerfectEnvironment_driver.c,687 :: 		exec_button->OnUpPtr( );
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #52
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up80:
;PerfectEnvironment_driver.c,688 :: 		if ( PressedObject == ( void * )exec_button )
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up81
;PerfectEnvironment_driver.c,689 :: 		if ( exec_button->OnClickPtr != 0 )
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #60
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up82
;PerfectEnvironment_driver.c,690 :: 		exec_button->OnClickPtr( );
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #60
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up82:
L_Process_TP_Up81:
;PerfectEnvironment_driver.c,691 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,692 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,693 :: 		return;
IT	AL
BAL	L_end_Process_TP_Up
;PerfectEnvironment_driver.c,694 :: 		}
L_Process_TP_Up79:
;PerfectEnvironment_driver.c,695 :: 		}
L_Process_TP_Up78:
;PerfectEnvironment_driver.c,698 :: 		if ( _object_count == label_order ) {
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up83
;PerfectEnvironment_driver.c,699 :: 		if ( exec_label->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
LDR	R2, [R2, #0]
ADDS	R2, #28
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Up84
;PerfectEnvironment_driver.c,700 :: 		if ( exec_label->OnUpPtr != 0 )
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #32
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up85
;PerfectEnvironment_driver.c,701 :: 		exec_label->OnUpPtr( );
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #32
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up85:
;PerfectEnvironment_driver.c,702 :: 		if ( PressedObject == ( void * )exec_label )
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up86
;PerfectEnvironment_driver.c,703 :: 		if ( exec_label->OnClickPtr != 0 )
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #40
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up87
;PerfectEnvironment_driver.c,704 :: 		exec_label->OnClickPtr( );
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #40
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up87:
L_Process_TP_Up86:
;PerfectEnvironment_driver.c,705 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,706 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,707 :: 		return;
IT	AL
BAL	L_end_Process_TP_Up
;PerfectEnvironment_driver.c,708 :: 		}
L_Process_TP_Up84:
;PerfectEnvironment_driver.c,709 :: 		}
L_Process_TP_Up83:
;PerfectEnvironment_driver.c,712 :: 		if ( _object_count == image_order ) {
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up88
;PerfectEnvironment_driver.c,713 :: 		if ( exec_image->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
LDR	R2, [R2, #0]
ADDS	R2, #21
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Up89
;PerfectEnvironment_driver.c,714 :: 		if ( exec_image->OnUpPtr != 0 )
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #24
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up90
;PerfectEnvironment_driver.c,715 :: 		exec_image->OnUpPtr( );
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #24
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up90:
;PerfectEnvironment_driver.c,716 :: 		if ( PressedObject == ( void * )exec_image )
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
LDR	R3, [R2, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
LDR	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Up91
;PerfectEnvironment_driver.c,717 :: 		if ( exec_image->OnClickPtr != 0 )
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #32
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Up92
;PerfectEnvironment_driver.c,718 :: 		exec_image->OnClickPtr( );
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #32
LDR	R2, [R4, #0]
BLX	R2
L_Process_TP_Up92:
L_Process_TP_Up91:
;PerfectEnvironment_driver.c,719 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,720 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,721 :: 		return;
IT	AL
BAL	L_end_Process_TP_Up
;PerfectEnvironment_driver.c,722 :: 		}
L_Process_TP_Up89:
;PerfectEnvironment_driver.c,723 :: 		}
L_Process_TP_Up88:
;PerfectEnvironment_driver.c,725 :: 		}
L_Process_TP_Up77:
;PerfectEnvironment_driver.c,726 :: 		PressedObject = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,727 :: 		PressedObjectType = -1;
MOVW	R3, #65535
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,728 :: 		}
L_end_Process_TP_Up:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Process_TP_Up
_Process_TP_Down:
;PerfectEnvironment_driver.c,730 :: 		void Process_TP_Down( unsigned int X, unsigned int Y) {
; Y start address is: 4 (R1)
; X start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
; X start address is: 0 (R0)
; Y start address is: 4 (R1)
;PerfectEnvironment_driver.c,732 :: 		object_pressed      = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_object_pressed+0)
MOVT	R2, #hi_addr(_object_pressed+0)
STRB	R3, [R2, #0]
;PerfectEnvironment_driver.c,733 :: 		exec_button         = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,734 :: 		exec_label          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,735 :: 		exec_image          = 0;
MOVS	R3, #0
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,737 :: 		Get_Object( X, Y);
; Y end address is: 4 (R1)
; X end address is: 0 (R0)
BL	_Get_Object+0
;PerfectEnvironment_driver.c,739 :: 		if ( _object_count != -1 ) {
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, #-1
IT	EQ
BEQ	L_Process_TP_Down93
;PerfectEnvironment_driver.c,740 :: 		if ( _object_count == button_order ) {
MOVW	R2, #lo_addr(_button_order+0)
MOVT	R2, #hi_addr(_button_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Down94
;PerfectEnvironment_driver.c,741 :: 		if ( exec_button->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #19
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Down95
;PerfectEnvironment_driver.c,742 :: 		if ( exec_button->PressColEnabled != 0 ) {
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
ADDS	R2, #48
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Down96
;PerfectEnvironment_driver.c,743 :: 		object_pressed = 1;
MOVS	R3, #1
MOVW	R2, #lo_addr(_object_pressed+0)
MOVT	R2, #hi_addr(_object_pressed+0)
STRB	R3, [R2, #0]
;PerfectEnvironment_driver.c,744 :: 		DrawButton( exec_button );
MOVW	R2, #lo_addr(_exec_button+0)
MOVT	R2, #hi_addr(_exec_button+0)
LDR	R2, [R2, #0]
MOV	R0, R2
BL	_DrawButton+0
;PerfectEnvironment_driver.c,745 :: 		}
L_Process_TP_Down96:
;PerfectEnvironment_driver.c,746 :: 		PressedObject = ( void * )exec_button;
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,747 :: 		PressedObjectType = 0;
MOVS	R3, #0
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,748 :: 		if ( exec_button->OnDownPtr != 0 ) {
LDR	R4, [R4, #0]
ADDS	R4, #56
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Down97
;PerfectEnvironment_driver.c,749 :: 		exec_button->OnDownPtr( );
MOVW	R4, #lo_addr(_exec_button+0)
MOVT	R4, #hi_addr(_exec_button+0)
LDR	R4, [R4, #0]
ADDS	R4, #56
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,750 :: 		return;
IT	AL
BAL	L_end_Process_TP_Down
;PerfectEnvironment_driver.c,751 :: 		}
L_Process_TP_Down97:
;PerfectEnvironment_driver.c,752 :: 		}
L_Process_TP_Down95:
;PerfectEnvironment_driver.c,753 :: 		}
L_Process_TP_Down94:
;PerfectEnvironment_driver.c,755 :: 		if ( _object_count == label_order ) {
MOVW	R2, #lo_addr(_label_order+0)
MOVT	R2, #hi_addr(_label_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Down98
;PerfectEnvironment_driver.c,756 :: 		if ( exec_label->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_label+0)
MOVT	R2, #hi_addr(_exec_label+0)
LDR	R2, [R2, #0]
ADDS	R2, #28
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Down99
;PerfectEnvironment_driver.c,757 :: 		PressedObject = ( void * )exec_label;
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,758 :: 		PressedObjectType = 2;
MOVS	R3, #2
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,759 :: 		if ( exec_label->OnDownPtr != 0 ) {
LDR	R4, [R4, #0]
ADDS	R4, #36
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Down100
;PerfectEnvironment_driver.c,760 :: 		exec_label->OnDownPtr( );
MOVW	R4, #lo_addr(_exec_label+0)
MOVT	R4, #hi_addr(_exec_label+0)
LDR	R4, [R4, #0]
ADDS	R4, #36
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,761 :: 		return;
IT	AL
BAL	L_end_Process_TP_Down
;PerfectEnvironment_driver.c,762 :: 		}
L_Process_TP_Down100:
;PerfectEnvironment_driver.c,763 :: 		}
L_Process_TP_Down99:
;PerfectEnvironment_driver.c,764 :: 		}
L_Process_TP_Down98:
;PerfectEnvironment_driver.c,766 :: 		if ( _object_count == image_order ) {
MOVW	R2, #lo_addr(_image_order+0)
MOVT	R2, #hi_addr(_image_order+0)
LDRSH	R3, [R2, #0]
MOVW	R2, #lo_addr(__object_count+0)
MOVT	R2, #hi_addr(__object_count+0)
LDRSH	R2, [R2, #0]
CMP	R2, R3
IT	NE
BNE	L_Process_TP_Down101
;PerfectEnvironment_driver.c,767 :: 		if ( exec_image->Active != 0 ) {
MOVW	R2, #lo_addr(_exec_image+0)
MOVT	R2, #hi_addr(_exec_image+0)
LDR	R2, [R2, #0]
ADDS	R2, #21
LDRB	R2, [R2, #0]
CMP	R2, #0
IT	EQ
BEQ	L_Process_TP_Down102
;PerfectEnvironment_driver.c,768 :: 		PressedObject = ( void * )exec_image;
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R3, [R4, #0]
MOVW	R2, #lo_addr(_PressedObject+0)
MOVT	R2, #hi_addr(_PressedObject+0)
STR	R3, [R2, #0]
;PerfectEnvironment_driver.c,769 :: 		PressedObjectType = 3;
MOVS	R3, #3
SXTH	R3, R3
MOVW	R2, #lo_addr(_PressedObjectType+0)
MOVT	R2, #hi_addr(_PressedObjectType+0)
STRH	R3, [R2, #0]
;PerfectEnvironment_driver.c,770 :: 		if ( exec_image->OnDownPtr != 0 ) {
LDR	R4, [R4, #0]
ADDS	R4, #28
LDR	R4, [R4, #0]
CMP	R4, #0
IT	EQ
BEQ	L_Process_TP_Down103
;PerfectEnvironment_driver.c,771 :: 		exec_image->OnDownPtr( );
MOVW	R4, #lo_addr(_exec_image+0)
MOVT	R4, #hi_addr(_exec_image+0)
LDR	R4, [R4, #0]
ADDS	R4, #28
LDR	R2, [R4, #0]
BLX	R2
;PerfectEnvironment_driver.c,772 :: 		return;
IT	AL
BAL	L_end_Process_TP_Down
;PerfectEnvironment_driver.c,773 :: 		}
L_Process_TP_Down103:
;PerfectEnvironment_driver.c,774 :: 		}
L_Process_TP_Down102:
;PerfectEnvironment_driver.c,775 :: 		}
L_Process_TP_Down101:
;PerfectEnvironment_driver.c,777 :: 		}
L_Process_TP_Down93:
;PerfectEnvironment_driver.c,778 :: 		}
L_end_Process_TP_Down:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Process_TP_Down
_Check_TP:
;PerfectEnvironment_driver.c,780 :: 		void Check_TP( ) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;PerfectEnvironment_driver.c,781 :: 		if ( FT5XX6_PressDetect( ) ) {
BL	_FT5XX6_PressDetect+0
CMP	R0, #0
IT	EQ
BEQ	L_Check_TP104
;PerfectEnvironment_driver.c,782 :: 		if ( FT5XX6_GetCoordinates( &Xcoord, &Ycoord ) == 0 ) {
MOVW	R1, #lo_addr(_Ycoord+0)
MOVT	R1, #hi_addr(_Ycoord+0)
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
BL	_FT5XX6_GetCoordinates+0
CMP	R0, #0
IT	NE
BNE	L_Check_TP105
;PerfectEnvironment_driver.c,784 :: 		Process_TP_Press( Xcoord, Ycoord );
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Press+0
;PerfectEnvironment_driver.c,785 :: 		if ( PenDown == 0 ) {
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L_Check_TP106
;PerfectEnvironment_driver.c,786 :: 		PenDown = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,787 :: 		Process_TP_Down( Xcoord, Ycoord );
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Down+0
;PerfectEnvironment_driver.c,788 :: 		}
L_Check_TP106:
;PerfectEnvironment_driver.c,789 :: 		}
L_Check_TP105:
;PerfectEnvironment_driver.c,790 :: 		}
IT	AL
BAL	L_Check_TP107
L_Check_TP104:
;PerfectEnvironment_driver.c,791 :: 		else if ( PenDown == 1 ) {
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L_Check_TP108
;PerfectEnvironment_driver.c,792 :: 		PenDown = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_PenDown+0)
MOVT	R0, #hi_addr(_PenDown+0)
STRB	R1, [R0, #0]
;PerfectEnvironment_driver.c,793 :: 		Process_TP_Up( Xcoord, Ycoord );
MOVW	R0, #lo_addr(_Ycoord+0)
MOVT	R0, #hi_addr(_Ycoord+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Xcoord+0)
MOVT	R0, #hi_addr(_Xcoord+0)
LDRH	R0, [R0, #0]
BL	_Process_TP_Up+0
;PerfectEnvironment_driver.c,794 :: 		}
L_Check_TP108:
L_Check_TP107:
;PerfectEnvironment_driver.c,795 :: 		}
L_end_Check_TP:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Check_TP
_Init_MCU:
;PerfectEnvironment_driver.c,797 :: 		void Init_MCU( )
SUB	SP, SP, #4
STR	LR, [SP, #0]
;PerfectEnvironment_driver.c,799 :: 		GPIO_Digital_Output( &GPIOF_BASE, _GPIO_PINMASK_1 );
MOVW	R1, #2
MOVW	R0, #lo_addr(GPIOF_BASE+0)
MOVT	R0, #hi_addr(GPIOF_BASE+0)
BL	_GPIO_Digital_Output+0
;PerfectEnvironment_driver.c,800 :: 		GPIO_Digital_Input( &GPIOF_BASE, _GPIO_PINMASK_0 );
MOVW	R1, #1
MOVW	R0, #lo_addr(GPIOF_BASE+0)
MOVT	R0, #hi_addr(GPIOF_BASE+0)
BL	_GPIO_Digital_Input+0
;PerfectEnvironment_driver.c,801 :: 		GPIOF_ODR.B1 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOF_ODR+0)
MOVT	R0, #hi_addr(GPIOF_ODR+0)
_SX	[R0, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,802 :: 		while ( GPIOF_IDR.B0 == 0 ) {
L_Init_MCU109:
MOVW	R0, #lo_addr(GPIOF_IDR+0)
MOVT	R0, #hi_addr(GPIOF_IDR+0)
_LX	[R0, ByteOffset(GPIOF_IDR+0)]
CMP	R0, #0
IT	NE
BNE	L_Init_MCU110
;PerfectEnvironment_driver.c,803 :: 		GPIOF_ODR.B1 = 0;
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOF_ODR+0)
MOVT	R0, #hi_addr(GPIOF_ODR+0)
_SX	[R0, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,804 :: 		Delay_us( 10 );
MOVW	R7, #558
MOVT	R7, #0
NOP
NOP
L_Init_MCU111:
SUBS	R7, R7, #1
BNE	L_Init_MCU111
NOP
NOP
NOP
;PerfectEnvironment_driver.c,805 :: 		GPIOF_ODR.B1 = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOF_ODR+0)
MOVT	R0, #hi_addr(GPIOF_ODR+0)
_SX	[R0, ByteOffset(GPIOF_ODR+0)]
;PerfectEnvironment_driver.c,806 :: 		Delay_us( 10 );
MOVW	R7, #558
MOVT	R7, #0
NOP
NOP
L_Init_MCU113:
SUBS	R7, R7, #1
BNE	L_Init_MCU113
NOP
NOP
NOP
;PerfectEnvironment_driver.c,807 :: 		}
IT	AL
BAL	L_Init_MCU109
L_Init_MCU110:
;PerfectEnvironment_driver.c,808 :: 		I2C2_Init_Advanced( 400000, &_GPIO_MODULE_I2C2_PF01 );
MOVW	R1, #lo_addr(__GPIO_MODULE_I2C2_PF01+0)
MOVT	R1, #hi_addr(__GPIO_MODULE_I2C2_PF01+0)
MOVW	R0, #6784
MOVT	R0, #6
BL	_I2C2_Init_Advanced+0
;PerfectEnvironment_driver.c,810 :: 		TFT_Set_Default_Mode( );
BL	_TFT_Set_Default_Mode+0
;PerfectEnvironment_driver.c,811 :: 		}
L_end_Init_MCU:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Init_MCU
_FT5XX6_Config:
;PerfectEnvironment_driver.c,813 :: 		char FT5XX6_Config( )  {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;PerfectEnvironment_driver.c,814 :: 		FT5XX6_SetI2CAddress( 0x38 );
MOVS	R0, #56
BL	_FT5XX6_SetI2CAddress+0
;PerfectEnvironment_driver.c,815 :: 		if ( FT5XX6_IsOperational( ) != FT5XX6_OK )
BL	_FT5XX6_IsOperational+0
CMP	R0, #0
IT	EQ
BEQ	L_FT5XX6_Config115
;PerfectEnvironment_driver.c,816 :: 		return  FT5XX6_FAILURE;
MOVS	R0, #1
IT	AL
BAL	L_end_FT5XX6_Config
L_FT5XX6_Config115:
;PerfectEnvironment_driver.c,817 :: 		FT5XX6_SetDefaultMode( );
BL	_FT5XX6_SetDefaultMode+0
;PerfectEnvironment_driver.c,818 :: 		FT5XX6_SetController( _TC_FT5X16);
MOVS	R0, #2
BL	_FT5XX6_SetController+0
;PerfectEnvironment_driver.c,819 :: 		FT5XX6_SetSizeAndRotation( 480,272,0 );
MOVS	R2, #0
MOVW	R1, #272
MOVW	R0, #480
BL	_FT5XX6_SetSizeAndRotation+0
;PerfectEnvironment_driver.c,820 :: 		return FT5XX6_OK;
MOVS	R0, #0
;PerfectEnvironment_driver.c,821 :: 		}
L_end_FT5XX6_Config:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _FT5XX6_Config
_Start_TP:
;PerfectEnvironment_driver.c,823 :: 		void Start_TP( ) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;PerfectEnvironment_driver.c,824 :: 		Init_MCU( );
BL	_Init_MCU+0
;PerfectEnvironment_driver.c,826 :: 		InitializeTouchPanel( );
BL	PerfectEnvironment_driver_InitializeTouchPanel+0
;PerfectEnvironment_driver.c,827 :: 		if ( FT5XX6_Config( ) == FT5XX6_OK ) {
BL	_FT5XX6_Config+0
CMP	R0, #0
IT	NE
BNE	L_Start_TP116
;PerfectEnvironment_driver.c,828 :: 		} else {
IT	AL
BAL	L_Start_TP117
L_Start_TP116:
;PerfectEnvironment_driver.c,829 :: 		while(1 );
L_Start_TP118:
IT	AL
BAL	L_Start_TP118
;PerfectEnvironment_driver.c,830 :: 		}
L_Start_TP117:
;PerfectEnvironment_driver.c,832 :: 		InitializeObjects( );
BL	PerfectEnvironment_driver_InitializeObjects+0
;PerfectEnvironment_driver.c,833 :: 		display_width = Screen1.Width;
MOVW	R0, #lo_addr(_Screen1+2)
MOVT	R0, #hi_addr(_Screen1+2)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_display_width+0)
MOVT	R0, #hi_addr(_display_width+0)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,834 :: 		display_height = Screen1.Height;
MOVW	R0, #lo_addr(_Screen1+4)
MOVT	R0, #hi_addr(_Screen1+4)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_display_height+0)
MOVT	R0, #hi_addr(_display_height+0)
STRH	R1, [R0, #0]
;PerfectEnvironment_driver.c,835 :: 		DrawScreen( &Screen1 );
MOVW	R0, #lo_addr(_Screen1+0)
MOVT	R0, #hi_addr(_Screen1+0)
BL	_DrawScreen+0
;PerfectEnvironment_driver.c,836 :: 		}
L_end_Start_TP:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Start_TP
PerfectEnvironment_driver____?ag:
L_end_PerfectEnvironment_driver___?ag:
BX	LR
; end of PerfectEnvironment_driver____?ag
